///////////////////////////////////////////////////////////////////////////////
// ACTION_IfGameState.uc
// Copyright 2002 Running With Scissors, Inc.  All Rights Reserved.
//
// Executes a section of actions only if the specified errand status is met.
//
//	History:
//		05/14/02 MJR	Started.
//
///////////////////////////////////////////////////////////////////////////////
class ACTION_IfBonus extends P2ScriptedAction;

var(Action) bool Is;
var(Action) int MissionNum;

function ProceedToNextAction(ScriptedController C)
	{
	local bool bResult;
	local P2GameInfoSingle game;
	local EAGameState TheGS;

	game = P2GameInfoSingle(C.Level.Game);
	TheGS = EAGameState(Game.TheGameState);
	if(game != None && TheGS != None)
		{
			bResult = (TheGS.IsBonus(MissionNum) == Is);
			log("compare"@is@"with"@thegs.isbonus(missionnum));
		}
	else
		warn("gameinfo or EAgamestate is none!!!!!");

	C.ActionNum += 1;
	if (!bResult)
		ProceedToSectionEnd(C);
	}

function bool StartsSection()
	{
	return true;
	}

function string GetActionString()
	{
		return ActionString@"check if"@MissionNum@"is"@Is;
	}

defaultproperties
{
     Is=True
     ActionString="If GameState Bonus: "
     bRequiresValidGameInfo=True
}
