class EAGameDemo extends EAGameInfo;

///////////////////////////////////////////////////////////////////////////////
// Start the game
///////////////////////////////////////////////////////////////////////////////
function StartGame(optional bool bEnhancedMode)
{
	local P2Player p2p;

	P2RootWindow(GetPlayer().Player.InteractionMaster.BaseMenu).StartingGame();

	// Stop any active SceneManager so player will have a pawn
	StopSceneManagers();

	// No longer used, make sure it's always off
	TheGameState.bNiceDude = false;

	PrepIniStartVals();

	TheGameState.bEGameStart = bEnhancedMode;

	// Get the difficulty ready for this game state.
	SetupDifficultyOnce();

	// Get rid of any things in his inventory before a new game starts
	p2p = GetPlayer();
	P2Pawn(p2p.pawn).DestroyAllInventory();

	// Unless of course it's the demo, then it *does* actaully just start.
	TheGameState.bChangeDayPostTravel = true;
	TheGameState.NextDay = 0;
	SendPlayerTo(GetPlayer(), StartFirstDayURL);
}

///////////////////////////////////////////////////////////////////////////////
// Returns true if player will be diverted home given the specified URL and
// telepad flag.  Other conditions are also taken into account when making
// this decision.
///////////////////////////////////////////////////////////////////////////////
function bool WillPlayerBeDivertedHome(String URL, bool bRealLevelExit)
{
	return false;
}

///////////////////////////////////////////////////////////////////////////////
// The player is back at his trailer and checking to see if he's ready to go
// something different. He can beat the game, beat the demo
///////////////////////////////////////////////////////////////////////////////
function AtPlayerHouse(P2Player p2p)
{
	// STUB
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// StartUp
// Do things at the absolute last moment before the game starts
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
auto state StartUp
{
	///////////////////////////////////////////////////////////////////////////////
	// The gameinfo has everything ready so now we tell the player controller
	// to prepare itself for a save. Make sure though, that it's allowed--demo versions can't save.	
	// Instead, the demo version forces the map to come up, since the Intro movie isn't there
	// to have the map come up. Only do this though, on the start of the first day
	// in the first level.
	///////////////////////////////////////////////////////////////////////////////
	function PrepPlayerStartup()
	{
		local P2Player p2p;

		p2p = GetPlayer();

		//log(self$" PrepPlayerStartup "$p2p$" first "$TheGameState.bFirstLevelOfDay);
		if(p2p != None
			&& TheGameState.bFirstLevelOfDay)
		{
			//log(self$" requesting map ");
			p2p.ForceMapUp();
		}
	}
}

defaultproperties
{
     GameNameShort="Demo"
     Begin Object Class=DayBase Name=DayBaseDemo
         Description="Demoday"
         UniqueName="DEMO"
         ExcludeDays(0)="Day_A"
         ExcludeDays(1)="Day_B"
         ExcludeDays(2)="Day_C"
         ExcludeDays(3)="Day_D"
         ExcludeDays(4)="Day_E"
         MapTex="EATex.Map.map_demo_aw7"
         NewsTex="p2misc.newspaper_day_1"
         DudeNewsComment="DudeDialog.dude_news_monday"
         LoadTex="p2misc.load.loading1_demo"
         DudeStartComment="DudeDialog.dude_map_exit1"
         PlayerInvList(0)=(InvClassName="Inventory.MoneyInv",NeededAmount=20)
         PlayerInvList(1)=(InvClassName="Inventory.MapInv")
         PlayerInvList(2)=(InvClassName="EAInventory.EAHandsWeapon")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="EAInventory.EADudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MilkInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.PaycheckInv")
         Name="DayBaseDemo"
     End Object
     Days(0)=DayBase'EAGame.DayBaseDemo'
     Begin Object Class=DayBase Name=DayBase86
         Description="Tuesday"
         UniqueName="DAY_B"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day2"
         NewsTex="p2misc_full.newspaper_day_2"
         DudeNewsComment="DudeDialog.dude_news_tuesday"
         LoadTex="EA_Product.Full.Loading_Tuesday"
         DudeStartComment="DudeDialog.dude_map_exit2"
         PlayerInvList(0)=(InvClassName="Inventory.LibraryBookInv")
         PlayerInvList(1)=(InvClassName="EAInventory.EAClipboardWeapon")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="EAInventory.EAGimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="EAInventory.EADudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="EAInventory.EAClipboardWeapon")
         TakeFromPlayerList(4)=(InvClassName="Inventory.LibraryBookInv")
         Name="DayBase86"
     End Object
     Days(1)=DayBase'EAGame.DayBase86'
     Begin Object Class=DayBase Name=DayBase87
         Description="Wednesday"
         UniqueName="DAY_C"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day3"
         NewsTex="p2misc_full.newspaper_day_3"
         DudeNewsComment="DudeDialog.dude_news_wednesday"
         LoadTex="EA_Product.Full.Loading_Wednesday"
         DudeStartComment="DudeDialog.dude_map_exit3"
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="EAInventory.EAGimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="EAInventory.EADudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.TreeInv")
         Name="DayBase87"
     End Object
     Days(2)=DayBase'EAGame.DayBase87'
     Begin Object Class=DayBase Name=DayBase88
         Description="Thursday"
         UniqueName="DAY_D"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day4"
         NewsTex="p2misc_full.newspaper_day_4"
         DudeNewsComment="DudeDialog.dude_news_thursday"
         LoadTex="EA_Product.Full.Loading_Thursday"
         DudeStartComment="DudeDialog.dude_map_exit4"
         PlayerInvList(0)=(InvClassName="Inventory.CitationInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="EAInventory.EAGimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="EAInventory.EADudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.KrotchyInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.SteakInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.CitationInv")
         Name="DayBase88"
     End Object
     Days(3)=DayBase'EAGame.DayBase88'
     Begin Object Class=DayBase Name=DayBase89
         Description="Friday"
         UniqueName="DAY_E"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day5"
         NewsTex="p2misc_full.newspaper_day_5"
         DudeNewsComment="DudeDialog.dude_news_friday"
         LoadTex="EA_Product.Full.Loading_Friday"
         DudeStartComment="DudeDialog.dude_map_exit5"
         PlayerInvList(0)=(InvClassName="Inventory.GiftInv")
         PlayerInvList(1)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.ParcelInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.AlternatorInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.PillsInv")
         TakeFromPlayerList(6)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(7)=(InvClassName="Inventory.MapInv")
         TakeFromPlayerList(8)=(InvClassName="Inventory.GiftInv")
         TakeFromPlayerList(9)=(InvClassName="Inventory.GaryBookInv")
         Name="DayBase89"
     End Object
     MatSwaps(0)=(OrigMat=Texture'Josh-textures.signs.game_banner_2',NewMat=Texture'Josh-textures.signs.game_banner_5')
     MatSwaps(1)=(OrigMat=Texture'Timb.arcade.Game_FagHunter',NewMat=Texture'Timb.arcade.Game_BastardFish')
     bIsDemo=True
     GameName="EA Demo"
}
