///////////////////////////////////////////////////////////////////////////////
// EAHUD
// Heat vision stuff as well as other EA-specific overlays
///////////////////////////////////////////////////////////////////////////////
class EAHUD extends AWWrapHUD;

const TIME_X = 0.95;
const TIME_Y = 0.95;

//increase to move right
//increase to move downwards

const KILL_HUD_BACKGROUND_X_OFFSET =  +0.120;
const KILL_HUD_BACKGROUND_Y_OFFSET =  -0.120;
const ICONKILL_HUD_BACKGROUND_X_OFFSET =  +0.180;
const ICONKILL_HUD_BACKGROUND_Y_OFFSET =  -0.067;

const EDHUD_NUMBERS_KILL_OFFSET_X	= +0.16;
const EDHUD_NUMBERS_MAX_KILL_OFFSET_X	= +0.17;
const EDHUD_NUMBERS_KILLS_Y =  +0.02;

// Kamek: Countdown text
var HudPos CountdownPos;
const HUD_NUMBERS_COUNTDOWN_OFFSET_X = -0.025;
const HUD_NUMBERS_COUNTDOWN_OFFSET_Y = -0.025;
//const KILL_HUD_BACKGROUND_X_OFFSET =  +0.120;
//const KILL_HUD_BACKGROUND_Y_OFFSET =  -0.120;

//reload text offset
const RELOAD_HUD_NUMBERS_OFFSET_X			= -0.925;
const RELOAD_HUD_NUMBERS_OFFSET_Y			= -0.080;

//reload bg offset
const RELOAD_HUD_BG_OFFSET_X    = -0.087;
const RELOAD_HUD_BG_OFFSET_Y    = +0.040;

//Gun icon position
const GUN_OFFSET_X				= -0.90;
const GUN_OFFSET_Y				= -0.09;


//Health bag consts
const HUD_HEALTH_BAG_X_OFFSET                   = -0.925;
const HUD_HEALTH_BAG_Y_OFFSET                   = -0.271;

//Blood in the bag
const HUD_HEALTH_BAG_BLOOD_X_OFFSET                   = -0.925;
//const HUD_HEALTH_BAG_BLOOD_Y_OFFSET                   = -0.248;
const HUD_HEALTH_BAG_BLOOD_Y_OFFSET                   = -0.168;


// Relative positions of armor stuff
const HUD_ARMOR_NUMBERS_OFFSET_X	= -0.050;
const HUD_ARMOR_NUMBERS_OFFSET_Y	= +0.050;
const HUD_ARMOR_ICON_OFFSET_X		= -0.890;
const HUD_ARMOR_ICON_OFFSET_Y		= -0.100;
const HUD_ARMOR_ICON_SCALE			= 1.0;


// Relative positions ammo numbers
const HUD_NUMBERS_OFFSET_X			= -0.925;
const HUD_NUMBERS_MAX_AMMO_OFFSET_X	= -0.925;
const HUD_NUMBERS_OFFSET_Y			= -0.040;

// Inventory Item Position
const HUD_INVEN_OFFSET_X			= -0.875;
const HUD_INVEN_OFFSET_Y			= -0.132;

// Inventory numbers Position
const INVscope_NUMBERS_OFFSET_X			= -0.775;
const INVscope_NUMBERS_OFFSET_Y			= -0.049;


//increaseX to move right
//increaseY to move downwards


///////////////////////////////////////////////////////////////////////////////
// Cross for drawing police radio beacons
///////////////////////////////////////////////////////////////////////////////
var() Texture TheCross;
var() Texture BloodyBG, HealthBagBottom, HealthBlood, HealthBagTop;
var() color BloodColor;

simulated event DrawHUD(Canvas Canvas)
{

	// Of course, cast OurPlayer to your BulletPlayer class instead of ED_HeatVisionPlayer
	if (EADudePlayer(PlayerOwner) != None && EADudePlayer(PlayerOwner).bHeatVisionActive)
		EADudePlayer(PlayerOwner).RenderHeatvisionOverlay(Canvas);

	// Draw the heat vision overlays first, so they don't mess with our other HUD stuff.
	Super.DrawHUD(Canvas);
//	Super.SetupFonts();



}

//////////////////////////////////////////////////////////////////////////////
// Draw the hurt bars around the edges to show direction of the attacker.
///////////////////////////////////////////////////////////////////////////////

/*
simulated function DrawHurtBars(canvas Canvas, float Scale)
{
	local int i;
	local float HealthRatio;
	local float xpos, ypos, useh, usew, fadeamount;
	local Texture usetex;

	HealthRatio = (1.0 - PawnOwner.Health/PawnOwner.HealthMax);
//	if(HealthRatio < 0.0)
//		HealthRatio = 0.0;
//	else
//		HealthRatio = HURT_BAR_HEALTH_MOD*HealthRatio;

        		Canvas.Style = ERenderStyle.STY_Masked;

			//fadeamount = (OurPlayer.HurtBarTime[i])*OurPlayer.HurtBarAlpha;

			//Canvas.SetDrawColor(0,0,0); // shows bars in red
			//fadeamount = (OurPlayer.HurtBarTime[i])*SKULL_ALPHA;
					// less alphaed, but red like hurt bars

                                        Canvas.SetDrawColor(255,0,0);
						//fadeamount/2,fadeamount/2);
					usetex = Texture(SkullHurtBar);

					usew = usetex.USize*1.0;
					useh = usetex.VSize*1.0;
					xpos = 0.5;
					ypos = 0.5;

			Canvas.SetPos(
				xpos*CanvasWidth - Scale*(usew/2),
				ypos*CanvasHeight - Scale*(useh/2));
			Canvas.DrawTile(usetex,
				Scale*usew,
				Scale*useh,
				0, 0, usetex.USize, usetex.VSize);
//		}
//	}


}
*/

//dopamine Draw the blood
simulated function DrawBloodyBG(canvas Canvas, float Scale)
{
	//dopamine draw bloody corner
	Canvas.Style = ERenderStyle.STY_Normal;
	//Canvas.Style = ERenderStyle.STY_Modulated;
	Canvas.DrawColor = BloodColor;
	Canvas.SetPos(0, 0);
	Canvas.DrawIcon(BloodyBG, Scale);
	//Canvas.DrawTile(BloodyBG, BloodyBG.USize*Canvas.Scale, BloodyBG.VSize*Canvas.Scale, 0, 0, BloodyBG.USize, BloodyBG.VSize);
}


simulated function DrawInventory(canvas Canvas, float Scale)
{
	local Texture usetex;
	local String str;
	local OwnedInv OwnedOne;
	local P2PowerupInv CurrentItem;
	local String str1, str2;

	// Draw background
	//dopamine No, don't draw background
/*
	Canvas.Style = ERenderStyle.STY_Masked;
	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(IconPos[InvIndex].X + HUD_HEALTH_BAG_X_OFFSET)*CanvasWidth,
		(IconPos[InvIndex].Y + HUD_HEALTH_BAG_Y_OFFSET)*CanvasHeight);
	Canvas.DrawIcon(Texture(SectionBackground[HUD_INVENTORY]), Scale);
*/


	CurrentItem = P2PowerupInv(PawnOwner.SelectedItem);
	if(CurrentItem  != None)
	{
		// Draw inventory icon
		
                
 //              Canvas.Style = ERenderStyle.STY_Masked;    // testing tom


		Canvas.DrawColor = DefaultIconColor;
		usetex = Texture(CurrentItem.Icon);
		Canvas.SetPos(


               (IconPos[InvIndex].X+HUD_INVEN_OFFSET_X)*CanvasWidth,
               (IconPos[InvIndex].Y+HUD_INVEN_OFFSET_Y)*CanvasHeight);
		Canvas.DrawIcon(usetex, Scale);
		

//////////////////////////////////////////////////////////////////////////////////////////////////////   tom
		// Draw inventory count in text form (only if desired and if more than 1)
		if(CurrentItem.bDisplayAmount && CurrentItem.Amount > 1)
		{
			if(!CurrentItem.bDisplayAsFloat)
				str = ""$(int(CurrentItem.Amount));
			else
				str = ""$CurrentItem.Amount;
			MyFont.DrawTextEx(Canvas, CanvasWidth,
				(IconPos[InvIndex].X+INVscope_NUMBERS_OFFSET_X)*CanvasWidth,
				(IconPos[InvIndex].Y+INVScope_NUMBERS_OFFSET_Y)*CanvasHeight,
				str, 2);
		}
//////////////////////////////////////////////////////////////////////////////////////////////////////    tom

		if(P2GameInfoSingle(Level.Game) != None
			&& P2GameInfo(Level.Game).AllowInventoryHints())
		{
			// If you're getting mugged, give hints on what to do--override cop hints
			if(OurPlayer.GetMuggerHints(str1, str2))
			{
				if (str1 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[InvIndex].X+InvTextPos[0].X)* CanvasWidth, 
											(IconPos[InvIndex].Y+InvTextPos[0].Y) * CanvasHeight, str1, 0, true, EJ_Right);
				if (str2 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[InvIndex].X+InvTextPos[1].X) * CanvasWidth,
											(IconPos[InvIndex].Y+InvTextPos[1].Y) * CanvasHeight, str2, 0, true, EJ_Right);
			}
			// Draw text hints if we allow them and if the timer for them
			// is still good (or if we need to draw them forever)
			else if(InvHintDeathTime > Level.TimeSeconds
					|| InvHintDeathTime == INFINITE_HINT_TIME)
				{
				//CurrentItem.GetHints(PawnOwner, InvHint1, str2, str3);
				if (InvHint1 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[InvIndex].X+InvTextPos[0].X)* CanvasWidth, 
										(IconPos[InvIndex].Y+InvTextPos[0].Y) * CanvasHeight, InvHint1, 0, true, EJ_Right);
				if (InvHint2 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[InvIndex].X+InvTextPos[1].X) * CanvasWidth, 
										(IconPos[InvIndex].Y+InvTextPos[1].Y) * CanvasHeight, InvHint2, 0, true, EJ_Right);
				if (InvHint3 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[InvIndex].X+InvTextPos[2].X) * CanvasWidth, 
										(IconPos[InvIndex].Y+InvTextPos[2].Y) * CanvasHeight, InvHint3, 0, true, EJ_Right);
			}
		}
	}
}




simulated function DrawHealthAndArmor(canvas Canvas, float Scale)
	{
	local Texture usetex;
	local float HeartW, HeartH;
	local int UseHealth, UseArmor, HealthColor;
	
	local float HealthBloodScale;
	
	HealthBloodScale = (1.0 - PawnOwner.Health/PawnOwner.HealthMax);

	UseHealth = PawnOwner.GetHealthPercent();
	UseArmor = PawnOwner.GetArmorPercent();

	// Draw background of bag




	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(IconPos[HealthIndex].X + HUD_HEALTH_BAG_X_OFFSET)*CanvasWidth,
		(IconPos[HealthIndex].Y + HUD_HEALTH_BAG_Y_OFFSET)*CanvasHeight);
	Canvas.DrawIcon(HealthBagBottom, Scale);

        //draw the blood in the bag
        //Turn into the health below!!!!!!!!!!!!
/*       	Canvas.Style = ERenderStyle.STY_Masked;
	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(IconPos[HealthIndex].X + HUD_HEALTH_BAG_BLOOD_X_OFFSET)*CanvasWidth,
		(IconPos[HealthIndex].Y + HUD_HEALTH_BAG_BLOOD_Y_OFFSET)*CanvasHeight);
	Canvas.DrawIcon(HealthBlood, Scale);
*/







	// Draw the beating heart
//dopamine	Canvas.Style = ERenderStyle.STY_Masked;
//dopamine	if(UseHealth > 100)
//dopamine		HealthColor = 100;
//dopamine	else
//dopamine		HealthColor = UseHealth;

	// Make sure the health isn't zero and shouldn't be. If so, make it one.
	if(UseHealth == 0
		&& PawnOwner.Health > 0)
		UseHealth = 1;

	// Make the heart yellow when you're using the catnip, but it still gets redder
	// the more hurt you are.
//dopamine	if(OurPlayer.CatnipUseTime > 0)
//dopamine		Canvas.SetDrawColor(155+HealthColor,55+HealthColor*2,0);
//dopamine	else	// Make it normal-colored, but the more you get hurt, the redder it gets
//dopamine		Canvas.SetDrawColor(155+HealthColor,55+HealthColor*2,55+HealthColor*2);

	usetex = HealthBlood;



	HeartW = usetex.USize;// + (HeartPumpSizeX*usetex.USize - usetex.USize/4);
//	HeartH = usetex.VSize + (HeartPumpSizeY*usetex.VSize - usetex.VSize/4);

	HeartH = usetex.VSize * UseHealth * 0.01;




        //draw the blood in the bag
        //Turn into the health below!!!!!!!!!!!!
       	Canvas.Style = ERenderStyle.STY_Masked;
	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(IconPos[HealthIndex].X + HUD_HEALTH_BAG_BLOOD_X_OFFSET)*CanvasWidth,
		(IconPos[HealthIndex].Y + HUD_HEALTH_BAG_BLOOD_Y_OFFSET)*CanvasHeight);
//	Canvas.DrawIcon(HealthBlood, Scale);



//        Canvas.SetPos(
//		IconPos[HealthIndex].X*CanvasWidth - Scale*(HeartW/2),
//		IconPos[HealthIndex].Y*CanvasHeight - Scale*(HeartH/2));
	Canvas.DrawTile(usetex,
		Scale*HeartW,
		Scale-HeartH,
		0, 0, usetex.USize, usetex.VSize);



        // Draw health in text number form
	// dopamine No we are using a bar next
//        MyFont.DrawTextEx(Canvas, CanvasWidth,
//		(IconPos[HealthIndex].X + HUD_NUMBERS_OFFSET_X) * CanvasWidth,
//		(IconPos[HealthIndex].Y + HUD_NUMBERS_OFFSET_Y) * CanvasHeight,
//		""$UseHealth, 2);

        
        
        


        //dopamine are we going to use armor, and how?
        // silent-scope - of coarse, fucknub!!!
	//dopamine - You are such a dick LAWL!
	// Draw armor stuff if it's being used

		if(UseArmor > 0)
			{
			// Draw icon
	//		Canvas.Style = ERenderStyle.STY_Masked;
			Canvas.DrawColor = DefaultIconColor;
			Canvas.SetPos(
				(IconPos[HealthIndex].X + HUD_ARMOR_ICON_OFFSET_X) * CanvasWidth,
				(IconPos[HealthIndex].Y + HUD_ARMOR_ICON_OFFSET_Y) * CanvasHeight);

			Canvas.DrawIcon(OurPlayer.HudArmorIcon, Scale * HUD_ARMOR_ICON_SCALE);


			}





        //Draw forground of bag edges
//      	Canvas.Style = ERenderStyle.STY_Masked;


	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(IconPos[HealthIndex].X + HUD_HEALTH_BAG_X_OFFSET)*CanvasWidth,
		(IconPos[HealthIndex].Y + HUD_HEALTH_BAG_Y_OFFSET)*CanvasHeight);
	Canvas.DrawIcon(HealthBagTop, Scale);

	}



//dopamine draw the bloodyBG first
simulated function bool DrawPlayerStatus(canvas Canvas, optional bool bCriticalInfoOnly)
	{
	local bool bDisplayOtherStuff;
	local P2GameInfo p2g;
	local int viewstate;

	// If we're getting ready to commit suicide, display this helpful hint
	// and don't show any of the other hud stuff
	if(OurPlayer.IsReadyToCommitSuicide())
		DrawSuicideHints(canvas);
	else
		{
		// Make sure there's a pawn
		if(PawnOwner != None
			&& (OurPlayer.ViewTarget != OurPlayer.Pawn || !OurPlayer.bBehindView))
			{
			p2g = P2GameInfo(Level.Game);

			//if (p2g != None)
			DrawHurtBars(Canvas, Scale);
			DrawSniperBars(Canvas, Scale);

			if (!bCriticalInfoOnly)
				{
				
				//dopamine draw boss health and kill counts
                if(OurPlayer.ViewTarget == OurPlayer.Pawn)
				{
					if(KillIcon != None)
						DrawKillCount(Canvas, Scale);
					else if(BossIcon != None)
						DrawBossHealth(Canvas, Scale);

					// Kamek: draw Countdown Timer
					if (BulletPlayer(OurPlayer) != None
						&& BulletPlayer(OurPlayer).bCountDown)
						DrawCountdown(Canvas, Scale);
				}

				// If we're focussed on the player, provide his full hud
				if(OurPlayer.ViewTarget == OurPlayer.Pawn)
					{
					viewstate = OurPlayer.HudViewState;

                                        //draw bloodsplat and health and armour
					if(viewstate > 0){
                                                if (P2GameInfoSingle(Level.Game) != None){
                                                   //dopamine Always draw it first no matter what (change for viewstates later)
                                                   DrawBloodyBG(Canvas, Scale);
                                        	   DrawPlayerWantedStatus(Canvas, Scale);
                                                }
                                                DrawHealthAndArmor(Canvas, Scale);
					}if (viewstate > 1)
						DrawWeapon(Canvas, Scale);
					if (viewstate > 2)
						DrawInventory(Canvas, Scale);
					}

				// Put up helpful hints about viewing a rocket as it travels
				// if we're watching the rocket
				if(OurPlayer.IsInState('PlayerWatchRocket'))
					{
					DrawRocketHints(canvas);
					}
				else// Give the radar chance only if we're not driving a rocket
					{
					// Give the radar a chance to draw, it will decide
					// whether or not to draw the full image
					if(OurPlayer.ShowRadarAny())
						DrawRadar(Canvas, Scale);
					}
				}

			// Indicate that other hud stuff should be displayed
			bDisplayOtherStuff = true;
			}
		}

	return bDisplayOtherStuff;
	}
	
 

function SetInvHints(string str1, string str2, string str3, byte InfiniteTime)
{

}

function SetWeapHints(string str1, string str2, string str3, byte InfiniteTime)
{

}

///////////////////////////////////////////////////////////////////////////////
// Kamek: Leading Zero function
///////////////////////////////////////////////////////////////////////////////
function string LZero(int N, int Places)
{
	local string S;
	local int i;

	S = String(N);
	for (i=0; len(S)<Places; i++)
		S = "0" $ S;

	return S;
}

///////////////////////////////////////////////////////////////////////////////
// Kamek: Draw countdown
///////////////////////////////////////////////////////////////////////////////
function DrawCountdown(Canvas Canvas, float Scale)
{
	local float TimeStart, TimeLength, Elapsed, TimeLeft, Excess;
	local int Hours, Minutes, Seconds, Centi;
	local string FinalOut;
	
//	log(self@"DrawCountdown");

	TimeStart = BulletPlayer(OurPlayer).CountdownStart;
	TimeLength = BulletPlayer(OurPlayer).CountdownLength;

	Elapsed = Level.TimeSeconds - TimeStart;
	TimeLeft = TimeLength - Elapsed;
	
	if (TimeLeft <= 0)
		BulletPlayer(OurPlayer).StopCountdown(true);

	Hours = int(TimeLeft/3600);

	Minutes = Int((TimeLeft - float(Hours*3600)) / 60);

	Seconds = Int((TimeLeft - float(Hours*3600) - float(Minutes*60)));

	Excess = Hours*3600 + Minutes*60 + Seconds;
	Centi = int((TimeLeft - Excess) * 100);

	FinalOut = LZero(Hours,2) $ ":" $ LZero(Minutes, 2) $ ":" $ LZero(Seconds, 2) $ "." $ LZero(Centi, 2);
//	FinalOut = LZero(Minutes, 2) $ ":" $ LZero(Seconds, 2);

	// Draw background
	Canvas.Style = ERenderStyle.STY_Masked;
	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(CountdownPos.X + HUD_BACKGROUND_X_OFFSET)*CanvasWidth,
		(CountdownPos.Y + HUD_BACKGROUND_Y_OFFSET)*CanvasHeight);
	Canvas.DrawIcon(KillBkgd, Scale);

	// draw text showing number and max to reach
	MyFont.DrawTextEx(Canvas, CanvasWidth,
		(CountdownPos.X + HUD_NUMBERS_COUNTDOWN_OFFSET_X)*CanvasWidth,
		(CountdownPos.Y + HUD_NUMBERS_COUNTDOWN_OFFSET_Y)*CanvasHeight,
		FinalOut, 2);

//	MyFont.DrawTextEX(C, CanvasWidth, TIME_X * CanvasWidth, TIME_Y * CanvasHeight, FinalOut, 1, true, EJ_Right);
}


///////////////////////////////////////////////////////////////////////////////
// Draw player info during kill count missions
///////////////////////////////////////////////////////////////////////////////
function DrawKillCount(canvas Canvas, float Scale)
{
	local int UseMax, UseCount;

	AWPlayer(OurPlayer).GetKillCountVals(UseMax, UseCount);
	// check if newly killed, if so, shake the icon for this time
	if(ShakeKillTime == 0
		&& UseCount > LastKillCount)
	{
		ShakeKillTime = SHAKE_KILL_TIME;
		LastKillCount=UseCount;
	}

	// Draw background
	Canvas.Style = ERenderStyle.STY_Masked;
	Canvas.DrawColor = DefaultIconColor;
	Canvas.SetPos(
		(KillPos.X + KILL_HUD_BACKGROUND_X_OFFSET)*CanvasWidth,
		(KillPos.Y + KILL_HUD_BACKGROUND_Y_OFFSET)*CanvasHeight);
	Canvas.DrawIcon(KillBkgd, Scale);

//dopamine added for the red outline non sharp effect
	Canvas.Style = ERenderStyle.STY_Normal;

	Canvas.SetPos(											// if you should shake add it here
		(KillPos.X+ ICONKILL_HUD_BACKGROUND_X_OFFSET)*CanvasWidth - Scale*(KillIcon.USize/2)  + (ShakeKillTime*(FRand() - 0.5)*SHAKE_MOD*CanvasWidth),
		(KillPos.Y+ ICONKILL_HUD_BACKGROUND_Y_OFFSET)*CanvasHeight - Scale*(KillIcon.VSize/2) + (ShakeKillTime*(FRand() - 0.5)*SHAKE_MOD*CanvasHeight));
	// Draw icon of pawn you are trying to kill
	Canvas.DrawIcon(KillIcon, Scale);

	// draw text showing number and max to reach
	MyFont.DrawTextEx(Canvas, CanvasWidth,
		(KillPos.X+EDHUD_NUMBERS_KILL_OFFSET_X)*CanvasWidth,
		(KillPos.Y+EDHUD_NUMBERS_KILLS_Y)*CanvasHeight,
		""$UseCount, 2);

	MyFont.DrawTextEx(Canvas, CanvasWidth,
		(KillPos.X+EDHUD_NUMBERS_MAX_KILL_OFFSET_X)*CanvasWidth,
		(KillPos.Y+EDHUD_NUMBERS_KILLS_Y)*CanvasHeight,
		"/"$UseMax, 2);
}

///////////////////////////////////////////////////////////////////////////////
// Draw weapon section
///////////////////////////////////////////////////////////////////////////////
simulated function DrawWeapon(canvas Canvas, float Scale)
	{
	local Texture usetex;
	local P2Weapon myweap;
	local String str1, str2;

	//log(self$" draw weapon, "$PawnOwner.Weapon);
	//if(PawnOwner.Weapon != None)
	//	log(self$" ammo "$P2AmmoInv(PawnOwner.Weapon.AmmoType));
	if(PawnOwner.Weapon != None && P2AmmoInv(PawnOwner.Weapon.AmmoType) != None)
		{




//dopamine removed bloodsplats
/*
		// Draw background
		Canvas.Style = ERenderStyle.STY_Masked;
		Canvas.DrawColor = DefaultIconColor;
		Canvas.SetPos(
			(IconPos[WeapIndex].X + HUD_BACKGROUND_X_OFFSET)*CanvasWidth,
			(IconPos[WeapIndex].Y + HUD_BACKGROUND_Y_OFFSET)*CanvasHeight);
		Canvas.DrawIcon(Texture(SectionBackground[HUD_AMMO]), Scale);
*/





		// Draw ammo icon
		Canvas.Style = ERenderStyle.STY_Normal;
		Canvas.DrawColor = DefaultIconColor;
		usetex = Texture(PawnOwner.Weapon.Texture);
		if(usetex != None)
			{
//			Canvas.SetPos(
//				IconPos[WeapIndex].X*CanvasWidth - Scale*(usetex.USize/2),
//				IconPos[WeapIndex].Y*CanvasHeight - Scale*(usetex.VSize/2));
          		Canvas.SetPos(
	        		(IconPos[WeapIndex].X + GUN_OFFSET_X)*CanvasWidth,
		        	(IconPos[WeapIndex].Y + GUN_OFFSET_Y)*CanvasHeight);
			Canvas.DrawIcon(usetex, Scale);
			}

		// Draw ammo count in text number form
		if(P2AmmoInv(PawnOwner.Weapon.AmmoType).bShowAmmoOnHud)
			{
			MyFont.DrawTextEx(Canvas, CanvasWidth,
				(IconPos[WeapIndex].X+HUD_NUMBERS_OFFSET_X)*CanvasWidth,
				(IconPos[WeapIndex].Y+HUD_NUMBERS_OFFSET_Y)*CanvasHeight,
				""$PawnOwner.Weapon.AmmoType.AmmoAmount, 2);

			//dopamine//// Draw the reloadcount
       			MyFont.DrawTextEx(Canvas, CanvasWidth,
				(IconPos[WeapIndex].X+RELOAD_HUD_NUMBERS_OFFSET_X)*CanvasWidth,
				(IconPos[WeapIndex].Y+RELOAD_HUD_NUMBERS_OFFSET_Y)*CanvasHeight,
				""$PawnOwner.Weapon.ReloadCount, 2);
                       ////////////////

			if(P2AmmoInv(PawnOwner.Weapon.AmmoType).bShowMaxAmmoOnHud)
				{
				MyFont.DrawTextEx(Canvas, CanvasWidth,
					(IconPos[WeapIndex].X+HUD_NUMBERS_MAX_AMMO_OFFSET_X)*CanvasWidth,
					(IconPos[WeapIndex].Y+HUD_NUMBERS_OFFSET_Y)*CanvasHeight,
					"/"$PawnOwner.Weapon.AmmoType.MaxAmmo, 2);
				}
			}

		// Draw text hints
		myweap = P2Weapon(PawnOwner.Weapon);
		if(myweap != None
			&& P2GameInfoSingle(Level.Game) != None
			&& P2GameInfo(Level.Game).AllowInventoryHints())
			{
			// Weapon hints (how to use them)
			if(WeapHintDeathTime > Level.TimeSeconds
				|| WeapHintDeathTime == INFINITE_HINT_TIME)
				{
				if (WeapHint1 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[WeapIndex].X+WeapTextPos[0].X) * CanvasWidth,
											(IconPos[WeapIndex].Y+WeapTextPos[0].Y) * CanvasHeight, WeapHint1, 0, true, EJ_Right);
				if (WeapHint2 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[WeapIndex].X+WeapTextPos[1].X) * CanvasWidth,
											(IconPos[WeapIndex].Y+WeapTextPos[1].Y) * CanvasHeight, WeapHint2, 0, true, EJ_Right);
				if (WeapHint3 != "")
					MyFont.DrawTextEx(Canvas, CanvasWidth, (IconPos[WeapIndex].X+WeapTextPos[2].X) * CanvasWidth,
											(IconPos[WeapIndex].Y+WeapTextPos[2].Y) * CanvasHeight, WeapHint3, 0, true, EJ_Right);
				}
			}
		}

	}

///////////////////////////////////////////////////////////////////////////////
// Quick alias for drawing right aligned text.
///////////////////////////////////////////////////////////////////////////////
function WriteTextR(Canvas Canvas, float X, float Y, string S)
{
	MyFont.DrawTextEX(Canvas, Canvas.SizeX, X, Y, S, 0, True, EJ_Right);
}

///////////////////////////////////////////////////////////////////////////////
// PostRender
// Render heat vision in addition to normal HUD overlays.
///////////////////////////////////////////////////////////////////////////////
simulated event PostRender(canvas Canvas)
{
	local HUD H;
	local float YL,YPos;
	local Pawn P;
	local Weapon W;
	local string WeaponName;


	// If a movie is playing, let Super handle everything
	if(TextureMovie != NONE && TextureMovie.Movie != NONE && TextureMovie.Movie.IsPlaying())
	{
		Super.PostRender(Canvas);
		return;
	}

	// If there's an active screen, check to see if it wants the hud
	// If there's a root window running then never show the hud
	if ((OurPlayer.CurrentScreen == None || OurPlayer.CurrentScreen.ShouldDrawHUD()) && !AreAnyRootWindowsRunning())
	{
		if ( !OurPlayer.bBehindView )
		{
			// Draw your foot in now
			if ( (PawnOwner != None) && (PawnOwner.MyFoot != None) )
				PawnOwner.MyFoot.RenderOverlays(Canvas);
		}

		// Do rest of weapons and hud
		if ( !OurPlayer.bBehindView )
		{
			P = Pawn(OurPlayer.ViewTarget);
			if ( (P != None) && (P.Weapon != None) )
				P.Weapon.RenderOverlays(Canvas);
		}

		// Of course, cast OurPlayer to your BulletPlayer class instead of ED_HeatVisionPlayer
		if (EADudePlayer(OurPlayer) != None && EADudePlayer(OurPlayer).bHeatVisionActive)
			EADudePlayer(OurPlayer).RenderHeatvisionOverlay(Canvas);

		DisplayMessages(Canvas);

		DrawTimeOnScreen(Canvas);

		bHideCenterMessages = DrawLevelAction(Canvas);

		if ( !bHideCenterMessages && (OurPlayer.ProgressTimeOut > Level.TimeSeconds) )
			DisplayProgressMessage(Canvas);

		if ( bBadConnectionAlert )
			DisplayBadConnectionAlert();

		if ( bShowDebugInfo )
		{
			YPos = 5;
			UseSmallFont(Canvas);
			OurPlayer.ViewTarget.DisplayDebug(Canvas,YL,YPos);
		}
		else for ( H=self; H!=None; H=H.NextHUD )
			H.DrawHUD(Canvas);

	// Give game info a chance to show debug stuff
	if (P2GameInfoSingle(Level.Game) != None)
		P2GameInfoSingle(Level.Game).RenderOverlays(Canvas);
	}

	// Display text saying who this version was issued to
	DrawIssuedToText(Canvas);

	if (OurPlayer.Pawn != None && OurPlayer.Pawn.FindInventoryType(class'CopRadioInv') != None)
		DrawRadioBeacons(Canvas);

	// Of course, cast OurPlayer to your BulletPlayer class instead of ED_HeatVisionPlayer
	if (EADudePlayer(OurPlayer) != None && EADudePlayer(OurPlayer).bWallHackActive)
		RenderWallHackOverlay(Canvas);

	// Get weapon name
	if (W != None && W.ItemName != "")
		WeaponName = W.ItemName;
	else
		WeaponName = "Unknown";

//	DrawCellBeacons(Canvas);
}

///////////////////////////////////////////////////////////////////////////////
// Draw wall hack overlay
///////////////////////////////////////////////////////////////////////////////
function RenderWallHackOverlay (Canvas Canvas)
{
	local Controller C;

	for (C=Level.ControllerList; C!=None; C=C.NextController)
	{
		if (C != Self && C.Pawn != None && !C.Pawn.bHidden)
		{
			if (!FastTrace(OurPlayer.Pawn.Location, C.Pawn.Location))
				Canvas.DrawActor(C.Pawn, true);
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// Draws a cop beacon on the radar.
///////////////////////////////////////////////////////////////////////////////
function DrawBeaconOnRadar (CopRadioBeacon Target, Canvas Canvas)
{
	local vector MyLocation;
	local vector TargetLocation;
	local vector DiffLocation;
	local vector X,Y,Z;

	local float  ScreenPosX;
	local float  ScreenPosY;

	local string DistanceInfo;
	local string HealthInfo;
	local string NameInfo;
	local color OurDrawColor;
	//local string WpnInfo, InvInfo;

	if (OurPlayer.ViewTarget != None)
	{
		MyLocation = OurPlayer.ViewTarget.Location;
		if (Pawn(OurPlayer.Viewtarget) != None)
			MyLocation.Z += Pawn(OurPlayer.Viewtarget).EyeHeight;
	}
	else
		MyLocation = OurPlayer.Location;

	TargetLocation = Target.Location;
	TargetLocation.Z += Target.CollisionHeight / 2;

	DiffLocation = TargetLocation - MyLocation;

	GetAxes(Normalize(OurPlayer.Rotation),X,Y,Z);

	if (DiffLocation Dot X > 0.70)
	{
		//log("Attempting to draw" @ Target @ "on" @ Canvas);
		ScreenPosX = (Canvas.ClipX / 2) + ( (DiffLocation Dot Y)) * ((Canvas.ClipX / 2) / Tan(OurPlayer.FovAngle * Pi/360)) / (DiffLocation Dot X);
		ScreenPosY = (Canvas.ClipY / 2) + (-(DiffLocation Dot Z)) * ((Canvas.ClipX / 2) / Tan(OurPlayer.FovAngle * Pi/360)) / (DiffLocation Dot X);

		Canvas.SetPos(ScreenPosX - 8, ScreenPosY - 8);
		OurDrawColor=RedColor;

		if (Target.TimerRate - Target.TimerCounter <= 10)
		{
			OurDrawColor.A = Int(255*(Target.TimerRate - Target.TimerCounter)/10);
			//log("it's"@OurDrawColor.A);
		}
		Canvas.DrawColor = OurDrawColor;
		Canvas.Style=ERenderStyle.STY_Alpha;
		Canvas.DrawIcon(TheCross, 0.5);

		DistanceInfo = String(Int(VSize(DiffLocation) / 48));

		Canvas.Font = Canvas.SmallFont;

		Canvas.SetPos(ScreenPosX + 10, ScreenPosY);
		Canvas.DrawText(DistanceInfo);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Draw all cop radio beacons
///////////////////////////////////////////////////////////////////////////////
function DrawRadioBeacons(canvas Canvas)
{
	local CopRadioBeacon B;

	foreach DynamicActors(class'CopRadioBeacon', B)
		DrawBeaconOnRadar(B, Canvas);
}

/*
function DrawCellBeacons(canvas Canvas)
{
	local CellBeacon B;

	foreach DynamicActors(class'CellBeacon', B)
		DrawBeaconOnRadar(B, Canvas);
}
*/


simulated function DrawTimeOnScreen(Canvas C)
{
	local float Elapsed;
	local int Hours;
	local int Minutes;
	local float HrMin;
	local int Seconds;
	local string FinalOut;
	local float Excess;
	local int Centi;

	if (EAGameState(P2GameInfoSingle(Level.Game).TheGameState) == None
		|| !EAGameInfo(Level.Game).bDrawTime)
		return;

	Elapsed = EAGameState(P2GameInfoSingle(Level.Game).TheGameState).TimeElapsed;

	Hours = int(Elapsed/3600);

	Minutes = Int((Elapsed - float(Hours*3600)) / 60);

	Seconds = Int((Elapsed - float(Hours*3600) - float(Minutes*60)));

	Excess = Hours*3600 + Minutes*60 + Seconds;
	Centi = int((Elapsed - Excess) * 100);

//	Minutes = int(Elapsed/60);

//	HrMin = Hours*3600 + Minutes*60;

//	Seconds = int(Elapsed - HrMin);
//	Excess = Elapsed - HrMin - Seconds;
//	Centi = int(Excess * 100);

	FinalOut = LZero(Hours,2) $ ":" $ LZero(Minutes, 2) $ ":" $ LZero(Seconds, 2) $ "." $ LZero(Centi, 2);

	MyFont.TextColor = WhiteColor;
	MyFont.DrawTextEX(C, CanvasWidth, TIME_X * CanvasWidth, TIME_Y * CanvasHeight, FinalOut, 1, true, EJ_Right);
	MyFont.TextColor = RedColor;
}

///////////////////////////////////////////////////////////////////////////////
// Draw the icon and health of any given boss
///////////////////////////////////////////////////////////////////////////////
function DrawBossHealth(canvas Canvas, float Scale)
{
	local int UseMax, UseCount;

	AWPlayer(OurPlayer).GetBossVals(UseMax, UseCount);

	if(BossIcon != None)
	{
		// Draw background
		Canvas.Style = ERenderStyle.STY_Masked;
		Canvas.DrawColor = DefaultIconColor;

		Canvas.SetPos(
			(KillPos.X + KILL_HUD_BACKGROUND_X_OFFSET)*CanvasWidth,
			(KillPos.Y + KILL_HUD_BACKGROUND_Y_OFFSET)*CanvasHeight);
		Canvas.DrawIcon(KillBkgd, Scale);

	//dopamine added for the red outline non sharp effect
	Canvas.Style = ERenderStyle.STY_Normal;
		Canvas.SetPos(											// if you should shake add it here
			(KillPos.X+ICONKILL_HUD_BACKGROUND_X_OFFSET)*CanvasWidth - Scale*(BossIcon.USize/2),
			(KillPos.Y+ICONKILL_HUD_BACKGROUND_Y_OFFSET)*CanvasHeight - Scale*(BossIcon.VSize/2));
		// Draw icon of pawn you are trying to kill
		Canvas.DrawIcon(BossIcon, Scale);
		
	// draw text showing number and max to reach
	MyFont.DrawTextEx(Canvas, CanvasWidth,
		(KillPos.X+EDHUD_NUMBERS_KILL_OFFSET_X)*CanvasWidth,
		(KillPos.Y+EDHUD_NUMBERS_KILLS_Y)*CanvasHeight,
		""$UseCount, 2);
		/*
		MyFont.DrawTextEx(Canvas, CanvasWidth,
			(KillPos.X+EDHUD_NUMBERS_MAX_KILL_OFFSET_X)*CanvasWidth,
			(KillPos.Y+HUD_NUMBERS_OFFSET_Y)*CanvasHeight,
			"/"$UseMax, 2);
			*/
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     CountdownPos=(X=0.340000,Y=0.060000)
     BloodyBG=Texture'ED_Hud.blood'
     TheCross=Texture'EATex.Misc.MyCross'
     HealthBagBottom=Texture'ED_Hud.hbottom'
     HealthBlood=Texture'ED_Hud.hmiddle'
     HealthBagTop=Texture'ED_Hud.htop'
     HeartIcon=Texture'nathans.Inventory.heartinv'
     BloodColor=(B=255,G=255,R=255,A=128)
     startinjuries(0)=(Tex=Texture'Zo_Smeg.Special_Brushes.zo_gravel',xoff=-0.500000,yoff=-0.500000,Scale=2.000000,MoveTimeDilation=1.000000,MoveSpeed=0.400000,Red=255.000000,Green=100.000000,Blue=128.000000,Alpha=80.000000,redchange=2.000000,greenchange=-2.000000,bluechange=5.000000,alphachange=-18.000000,redmax=255.000000,greenmax=100.000000,bluemax=128.000000,AlphaMax=128.000000,redmin=200.000000,greenmin=60.000000,bluemin=50.000000,alphamin=1.000000)
     startinjuries(1)=(Tex=Texture'Zo_Smeg.Special_Brushes.zo_wash2_opaque',xoff=-0.500000,yoff=-0.500000,Scale=2.000000,MoveTimeDilation=1.500000,MoveSpeed=-0.200000,Red=40.000000,Green=20.000000,Blue=200.000000,Alpha=80.000000,greenchange=3.000000,bluechange=-4.000000,alphachange=-18.000000,redmax=100.000000,greenmax=120.000000,bluemax=255.000000,AlphaMax=128.000000,redmin=100.000000,greenmin=40.000000,bluemin=200.000000,alphamin=1.000000)
     startinjuries(2)=(Tex=Texture'Zo_Smeg.Ground_Alphas.zo_grnd_alpha2',Scale=1.000000,MoveTimeDilation=1.000000,Red=255.000000,Green=255.000000,Blue=255.000000,Alpha=255.000000,alphachange=-80.000000,AlphaMax=255.000000,alphamin=1.000000)
     walkinjuries(0)=(Tex=Texture'Zo_Smeg.Special_Brushes.zo_gravel',xoff=-0.500000,yoff=-0.500000,Scale=2.000000,MoveTimeDilation=0.500000,MoveSpeed=0.200000,Red=255.000000,Alpha=1.000000,redchange=2.000000,bluechange=1.000000,alphachange=4.000000,redmax=255.000000,bluemax=80.000000,AlphaMax=50.000000,redmin=200.000000,bluemin=1.000000,alphamin=20.000000)
     walkinjuries(1)=(Tex=Texture'Zo_Smeg.Special_Brushes.zo_wash2_opaque',xoff=-0.500000,yoff=-0.500000,Scale=2.000000,MoveTimeDilation=0.800000,MoveSpeed=-0.100000,Red=100.000000,Green=100.000000,Blue=200.000000,Alpha=1.000000,greenchange=1.000000,bluechange=-4.000000,alphachange=7.000000,redmax=100.000000,greenmax=255.000000,bluemax=255.000000,AlphaMax=50.000000,redmin=100.000000,greenmin=20.000000,bluemin=200.000000,alphamin=20.000000)
     stopinjuries(0)=(Tex=Texture'Zo_Smeg.Ground_Alphas.zo_grnd_alpha2',Scale=1.000000,MoveTimeDilation=1.000000,Red=255.000000,Green=255.000000,Blue=255.000000,Alpha=255.000000,alphachange=-80.000000,AlphaMax=255.000000,alphamin=1.000000)
     stopinjuries(1)=(Tex=Texture'Zo_Smeg.Ground_Alphas.zo_grnd_alpha2',Scale=1.000000,MoveTimeDilation=1.000000,Red=255.000000,Green=255.000000,Blue=255.000000,Alpha=255.000000,alphachange=-80.000000,AlphaMax=255.000000,alphamin=1.000000)
     garyeffects(0)=(Tex=Texture'Zo_Smeg.Special_Brushes.zo_gravel',xoff=-0.500000,yoff=-0.500000,Scale=2.000000,MoveTimeDilation=0.600000,MoveSpeed=0.300000,Green=180.000000,Alpha=1.000000,greenchange=2.000000,bluechange=1.000000,alphachange=3.000000,greenmax=180.000000,bluemax=80.000000,AlphaMax=50.000000,greenmin=100.000000,bluemin=1.000000,alphamin=20.000000)
     garyeffects(1)=(Tex=Texture'Zo_Smeg.Special_Brushes.zo_wash2_opaque',xoff=-0.500000,yoff=-0.500000,Scale=2.000000,MoveTimeDilation=0.700000,MoveSpeed=-0.150000,Red=50.000000,Green=100.000000,Blue=200.000000,Alpha=1.000000,greenchange=1.000000,bluechange=-4.000000,alphachange=7.000000,redmax=100.000000,greenmax=100.000000,bluemax=255.000000,AlphaMax=50.000000,redmin=50.000000,greenmin=20.000000,bluemin=200.000000,alphamin=20.000000)
     SectionBackground(0)=Texture'nathans.Inventory.bloodsplat-1'
     SectionBackground(1)=Texture'nathans.Inventory.bloodsplat-2'
     SectionBackground(2)=Texture'nathans.Inventory.bloodsplat-3'
     IconPos(0)=(X=0.935000,Y=0.120000)
     IconPos(1)=(X=0.935000,Y=0.270000)
     IconPos(2)=(X=0.935000,Y=0.420000)
     IconPos(3)=(X=0.935000,Y=0.570000)
     InvTextPos(0)=(X=-0.055000,Y=-0.035000)
     InvTextPos(1)=(X=-0.055000,Y=-0.010000)
     InvTextPos(2)=(X=-0.055000,Y=0.015000)
     WeapTextPos(0)=(X=-0.055000,Y=0.015000)
     WeapTextPos(1)=(X=-0.055000,Y=0.040000)
     WeapTextPos(2)=(X=-0.055000,Y=0.065000)
     WantedTextPos(0)=(X=-0.055000,Y=-0.030000)
     WantedTextPos(1)=(X=-0.055000)
     RocketHint2="Use the mouse to control the rocket."
//     FontInfoClass="EDShell.EDFontInfo"
     CategoryFormats(0)=(YP=0.900000,VAlign=TVA_Bottom)
}
