///////////////////////////////////////////////////////////////////////////////
// EAMutator
// Stuff that can only be handled in a mutator.
///////////////////////////////////////////////////////////////////////////////
class EAMutator extends Mutator;

///////////////////////////////////////////////////////////////////////////////
// Consts
///////////////////////////////////////////////////////////////////////////////
const FAST_ROCKETS = 3.00;
const SLOW_ROCKETS = 0.333333;

var array<Pawn> PendingPawns;

///////////////////////////////////////////////////////////////////////////////
// Vars
///////////////////////////////////////////////////////////////////////////////
var() string AWGrenadeClass;

event PostBeginPlay()
{
	Super.PostBeginPlay();
	log(self@"successfully added to game");
}

///////////////////////////////////////////////////////////////////////////////
// Check for replacements.
///////////////////////////////////////////////////////////////////////////////
function bool CheckReplacement(Actor Other, out byte bWhatever)
{
	local AWPerson P;
	local EAGameState TheState;
	local LauncherProjectile Proj;
	local float SpeedMod;
	local EADudePlayer PC;

	if (Pawn(Other) != None)
	{
		PC = EADudePlayer(P2GameInfo(Level.Game).GetPlayer());
		if (PC.bHeatVisionActive)
		{
			log("Adding heat vision pawn"@Other@"via mutator");
			PendingPawns.Insert(0,1);
			PendingPawns[0] = Pawn(Other);
		}
	}
	return true;
	log(self@"checking replacement of actor"@Other);
	// Replace grenade weapons with the AWGrenade which lets you kill people with kicked grenades.
	if (Other.Class == class'GrenadeWeapon' && !Pawn(Other.Owner).Controller.bIsPlayer)
	{
		return !ReplaceWith(Other, AWGrenadeClass);
	}

	// Replaces the military with EACivilians in Hate Me Mode (There was a reason for this but I forget what)
/*	if (AWPerson(Other) != None && P2GameInfo(Level.Game).TheyHateMeMode())
	{
		P = AWPerson(Other);
		if (P.ControllerClass == class'AWMilitaryController')
			P.ControllerClass = class'EACivilianController';
	}
*/

	// Enables the SlowRockets/FastRockets cheat
	if (LauncherProjectile(Other) != None)
	{
 		Proj = LauncherProjectile(Other);
		TheState = EAGameState(P2GameInfoSingle(Level.Game).TheGameState);

		if (TheState.bSlowRockets)
			SpeedMod = SLOW_ROCKETS;
		else if (TheState.bFastRockets)
			SpeedMod = FAST_ROCKETS;
		else
			SpeedMod = 1.000000;

		log(self@"altering Launcher Projectile"@Other@"controlled by player"@Other.Instigator.Controller.bIsPlayer@"speed mod"@SpeedMod);

		Proj.Speed = Proj.Speed * SpeedMod;
		Proj.MaxSpeed = Proj.MaxSpeed * SpeedMod;
		Proj.ForwardAccelerationMag = Proj.ForwardAccelerationMag * SpeedMod;
		if (LauncherSeekingProjectileTrad(Proj) != None)
			LauncherSeekingProjectileTrad(Proj).SeekingAccelerationMag = LauncherSeekingProjectileTrad(Proj).SeekingAccelerationMag * SpeedMod;
		if (LauncherSeekingProjectile(Proj) != None)
			LauncherSeekingProjectile(Proj).SeekingAccelerationMag = LauncherSeekingProjectile(Proj).SeekingAccelerationMag * SpeedMod;
	}

	return Super.CheckReplacement(Other, bWhatever);
}

simulated event Tick(float dT)
{
	local int i;
	local EADudePlayer PC;

	if (PendingPawns.Length != 0)
	{
		PC = EADudePlayer(P2GameInfo(Level.Game).GetPlayer());
		if (PC.bHeatVisionActive)
		{
			for (i=0; i<PendingPawns.Length; i++)
				PC.RegisterHeatPawn(PendingPawns[i]);
		}
		PendingPawns.Length = 0;
	}

    Super.Tick(dT);
}
///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     AWGrenadeClass="AWInventory.AWGrenadeWeapon"
}
