///////////////////////////////////////////////////////////////////////////////
// ACTION_SetBonus
// Sets a bonus mission as complete/incomplete
///////////////////////////////////////////////////////////////////////////////
class ACTION_SetBonus extends P2ScriptedAction;

///////////////////////////////////////////////////////////////////////////////
// Public vars
///////////////////////////////////////////////////////////////////////////////
var(Action) int MissionNum;
var(Action) bool bComplete;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool InitActionFor(ScriptedController C)
{
	local P2GameInfoSingle game;
	local EAGameState TheGS;

	game = P2GameInfoSingle(C.Level.Game);
	TheGS = EAGameState(Game.TheGameState);
	if(game != None && TheGS != None)
		TheGS.SetBonusMission(MissionNum, bComplete);

	return false;
}

function string GetActionString()
	{
		return ActionString@"set"@MissionNum@"to"@bComplete;
	}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     ActionString="Set bonus mission"
     bRequiresValidGameInfo=True
}
