class EAGameDemo extends EAGameInfo;

///////////////////////////////////////////////////////////////////////////////
// Start the game
///////////////////////////////////////////////////////////////////////////////
function StartGame(optional bool bEnhancedMode)
{
	local P2Player p2p;

	P2RootWindow(GetPlayer().Player.InteractionMaster.BaseMenu).StartingGame();

	// Stop any active SceneManager so player will have a pawn
	StopSceneManagers();

	// No longer used, make sure it's always off
	TheGameState.bNiceDude = false;

	PrepIniStartVals();

	TheGameState.bEGameStart = bEnhancedMode;

	// Get the difficulty ready for this game state.
	SetupDifficultyOnce();

	// Get rid of any things in his inventory before a new game starts
	p2p = GetPlayer();
	P2Pawn(p2p.pawn).DestroyAllInventory();

	// Unless of course it's the demo, then it *does* actaully just start.
	TheGameState.bChangeDayPostTravel = true;
	TheGameState.NextDay = 0;
	SendPlayerTo(GetPlayer(), StartFirstDayURL);
}

///////////////////////////////////////////////////////////////////////////////
// Returns true if player will be diverted home given the specified URL and
// telepad flag.  Other conditions are also taken into account when making
// this decision.
///////////////////////////////////////////////////////////////////////////////
function bool WillPlayerBeDivertedHome(String URL, bool bRealLevelExit)
{
	return false;
}

///////////////////////////////////////////////////////////////////////////////
// The player is back at his trailer and checking to see if he's ready to go
// something different. He can beat the game, beat the demo
///////////////////////////////////////////////////////////////////////////////
function AtPlayerHouse(P2Player p2p)
{
	// STUB
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// StartUp
// Do things at the absolute last moment before the game starts
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
auto state StartUp
{
	///////////////////////////////////////////////////////////////////////////////
	// The gameinfo has everything ready so now we tell the player controller
	// to prepare itself for a save. Make sure though, that it's allowed--demo versions can't save.	
	// Instead, the demo version forces the map to come up, since the Intro movie isn't there
	// to have the map come up. Only do this though, on the start of the first day
	// in the first level.
	///////////////////////////////////////////////////////////////////////////////
	function PrepPlayerStartup()
	{
		local P2Player p2p;

		p2p = GetPlayer();

		//log(self$" PrepPlayerStartup "$p2p$" first "$TheGameState.bFirstLevelOfDay);
		if(p2p != None
			&& TheGameState.bFirstLevelOfDay)
		{
			//log(self$" requesting map ");
			p2p.ForceMapUp();
		}
	}
}

defaultproperties
{
     GameNameShort="Demo"
     Begin Object Class=DayBase Name=DayBaseDemo
         Description="Demoday"
         UniqueName="DEMO"
         ExcludeDays(0)="7DayA"
         ExcludeDays(1)="7DayB"
         ExcludeDays(2)="7DayC"
         ExcludeDays(3)="7DayD"
         ExcludeDays(4)="7DayE"
         MapTex="EATex.Map.map_demo_aw7"
         NewsTex="p2misc.newspaper_day_1"
         DudeNewsComment="DudeDialog.dude_news_monday"
         LoadTex="p2misc.load.loading1_demo"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'EAGame.ErrandBaseDemo'
         PlayerInvList(0)=(InvClassName="Inventory.MoneyInv",NeededAmount=20)
         PlayerInvList(1)=(InvClassName="Inventory.MapInv")
         PlayerInvList(2)=(InvClassName="Inventory.HandsWeapon")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MilkInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.PaycheckInv")
         Name="DayBaseDemo"
     End Object
     Days(0)=DayBase'EAGame.DayBaseDemo'
     Begin Object Class=DayBase Name=DayBase86
         Description="Tuesday"
         UniqueName="7DAYB"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day2"
         NewsTex="p2misc_full.newspaper_day_2"
         DudeNewsComment="DudeDialog.dude_news_tuesday"
         LoadTex="p2misc_full.loading2"
         DudeStartComment="DudeDialog.dude_map_exit2"
         Errands(0)=ErrandBase'EAGame.ErrandBase3'
         Errands(1)=ErrandBase'EAGame.ErrandBase4'
         Errands(2)=ErrandBase'EAGame.ErrandBase5'
         Errands(3)=ErrandBase'EAGame.ErrandBase6'
         PlayerInvList(0)=(InvClassName="Inventory.LibraryBookInv")
         PlayerInvList(1)=(InvClassName="Inventory.ClipboardWeapon")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.ClipboardWeapon")
         TakeFromPlayerList(4)=(InvClassName="Inventory.LibraryBookInv")
         Name="DayBase86"
     End Object
     Days(1)=DayBase'EAGame.DayBase86'
     Begin Object Class=DayBase Name=DayBase87
         Description="Wednesday"
         UniqueName="7DAYC"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day3"
         NewsTex="p2misc_full.newspaper_day_3"
         DudeNewsComment="DudeDialog.dude_news_wednesday"
         LoadTex="p2misc_full.loading3"
         DudeStartComment="DudeDialog.dude_map_exit3"
         Errands(0)=ErrandBase'EAGame.ErrandBase7'
         Errands(1)=ErrandBase'EAGame.ErrandBase8'
         Errands(2)=ErrandBase'EAGame.ErrandBase9'
         Errands(3)=ErrandBase'EAGame.ErrandBase10'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.TreeInv")
         Name="DayBase87"
     End Object
     Days(2)=DayBase'EAGame.DayBase87'
     Begin Object Class=DayBase Name=DayBase88
         Description="Thursday"
         UniqueName="7DAYD"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day4"
         NewsTex="p2misc_full.newspaper_day_4"
         DudeNewsComment="DudeDialog.dude_news_thursday"
         LoadTex="p2misc_full.loading4"
         DudeStartComment="DudeDialog.dude_map_exit4"
         Errands(0)=ErrandBase'EAGame.ErrandBase11'
         Errands(1)=ErrandBase'EAGame.ErrandBase12'
         Errands(2)=ErrandBase'EAGame.ErrandBase13'
         Errands(3)=ErrandBase'EAGame.ErrandBase14'
         PlayerInvList(0)=(InvClassName="Inventory.CitationInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.KrotchyInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.SteakInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.CitationInv")
         Name="DayBase88"
     End Object
     Days(3)=DayBase'EAGame.DayBase88'
     Begin Object Class=DayBase Name=DayBase89
         Description="Friday"
         UniqueName="7DAYE"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day5"
         NewsTex="p2misc_full.newspaper_day_5"
         DudeNewsComment="DudeDialog.dude_news_friday"
         LoadTex="p2misc_full.loading5"
         DudeStartComment="DudeDialog.dude_map_exit5"
         Errands(0)=ErrandBase'EAGame.ErrandBase15'
         Errands(1)=ErrandBase'EAGame.ErrandBase16'
         Errands(2)=ErrandBase'EAGame.ErrandBase17'
         Errands(3)=ErrandBase'EAGame.ErrandBase18'
         PlayerInvList(0)=(InvClassName="Inventory.GiftInv")
         PlayerInvList(1)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.ParcelInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.AlternatorInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.PillsInv")
         TakeFromPlayerList(6)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(7)=(InvClassName="Inventory.MapInv")
         TakeFromPlayerList(8)=(InvClassName="Inventory.GiftInv")
         TakeFromPlayerList(9)=(InvClassName="Inventory.GaryBookInv")
         Name="DayBase89"
     End Object
     Days(4)=DayBase'EAGame.DayBase89'
     Begin Object Class=DayBase Name=DayBase90
         Description="Saturday"
         UniqueName="DAY_A"
         ExcludeDays(0)="DEMO"
         LoadTex="aw_textures.loading_sat"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AWGame.ErrandBase0'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
         Name="DayBase90"
     End Object
     Days(5)=DayBase'EAGame.DayBase90'
     Begin Object Class=DayBase Name=DayBase91
         Description="Sunday"
         UniqueName="DAY_B"
         ExcludeDays(0)="DEMO"
         LoadTex="aw_textures.loading_sun"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AWGame.ErrandBase1'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
         Name="DayBase91"
     End Object
     Days(6)=DayBase'EAGame.DayBase91'
     MatSwaps(0)=(OrigMat=Texture'Josh-textures.signs.game_banner_2',NewMat=Texture'Josh-textures.signs.game_banner_5')
     MatSwaps(1)=(OrigMat=Texture'Timb.arcade.Game_FagHunter',NewMat=Texture'Timb.arcade.Game_BastardFish')
     bIsDemo=True
     GameName="EA Demo"
}
