///////////////////////////////////////////////////////////////////////////////
// EAMapScreen
// "New" comments for dude during apocalypse and other EA-related stuff.
///////////////////////////////////////////////////////////////////////////////
class EAMapScreen extends MapScreen;

///////////////////////////////////////////////////////////////////////////////
// Public vars
///////////////////////////////////////////////////////////////////////////////
var() array<Sound> DudeApocalypse;

///////////////////////////////////////////////////////////////////////////////
// Play dude comment for the Apocalypse
///////////////////////////////////////////////////////////////////////////////
function float PlayApocalypseComment()
{
	return PlayDudeComment(DudeApocalypse[Rand(DudeApocalypse.length)]);
}

///////////////////////////////////////////////////////////////////////////////
// Player should go home
///////////////////////////////////////////////////////////////////////////////
state CheckReadyForHome
{
	function BeginState()
	{
		local float duration;

		log(self$" CheckReadyForHome lost: "$bDudeIsLost);

		// If dude is ready to go home then he makes a comment about it
		if (!bGoFast && GetGameSingle().IsPlayerReadyForHome() && !gs.bIsApocalypse)
		{
			duration = PreReadyForHome;
			DelayedGotoState(PreferredTime(duration), 'CheckReadyForHome2');
		}
		else if(!bGoFast && bDudeIsLost)
		{
			duration = PreReadyForHome; // smaller time to wait till he talks
			DelayedGotoState(PreferredTime(duration), 'PlayerIsLost');
		}
		else if(!bGoFast && gs.bIsApocalypse)
		{
			duration = PreReadyForHome; // smaller time to wait till he talks
			DelayedGotoState(PreferredTime(duration), 'ApocalypseMap');
		}
		else
		{
			duration = FMax(duration, BigHoldTime);
			DelayedGotoState(PreferredTime(duration), 'HoldScreen');
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Play some sounds to show that the dude's in the middle of the Apocalypse
///////////////////////////////////////////////////////////////////////////////
state ApocalypseMap extends ShowScreen
{
	function BeginState()
	{
		local float duration;

//		log(self$" comment on Apocalypse");
		// Make comment about the Apocalypse
		duration = PlayApocalypseComment();
		duration = FMax(duration, BigHoldTime);
		DelayedGotoState(PreferredTime(duration), 'HoldScreen');
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     DudeApocalypse(0)=Sound'DudeDialog.dude_howfarishome'
     DudeApocalypse(1)=Sound'DudeDialog.dude_map_apoc1'
     DudeApocalypse(2)=Sound'DudeDialog.dude_map_apoc2'
     DudeApocalypse(3)=Sound'DudeDialog.dude_map_apoc3'
     DudeApocalypse(4)=Sound'DudeDialog.dude_map_apoc4'
     DudeApocalypse(5)=Sound'DudeDialog.dude_notsoeasyhome'
     DudeApocalypse(6)=Sound'DudeDialog.dude_nowicanseemusic'
     DudeApocalypse(7)=Sound'DudeDialog.dude_thoughtidbehome'
     DudeApocalypse(8)=Sound'DudeDialog.dude_walkhomeseemslong'
     ErrandPositions(0)=(X=83.000000,Y=616.000000)
     ErrandPositions(1)=(X=101.000000,Y=691.000000)
     ErrandPositions(2)=(X=119.000000,Y=775.000000)
     ErrandPositions(3)=(X=131.000000,Y=832.000000)
     CrossoutTex(0)=Texture'P2Misc.Map.crossout_1'
     CrossoutTex(1)=Texture'P2Misc.Map.crossout_2'
     CrossoutTex(2)=Texture'P2Misc.Map.crossout_3'
     CrossoutTex(3)=Texture'P2Misc.Map.crossout_4'
     HaterDesPositions(0)=(X=332.000000,Y=154.000000)
     HaterDesPositions(1)=(X=172.000000,Y=295.000000)
     HaterDesPositions(2)=(X=223.000000,Y=414.000000)
     HaterDesPositions(3)=(X=66.000000,Y=609.000000)
     HaterDesPositions(4)=(X=47.000000,Y=169.000000)
     HaterDesPositions(5)=(X=100.000000,Y=100.000000)
     HaterPicPositions(0)=(X=151.000000,Y=85.000000)
     HaterPicPositions(1)=(X=109.000000,Y=336.000000)
     HaterPicPositions(2)=(X=794.000000,Y=436.000000)
     HaterPicPositions(3)=(X=776.000000,Y=179.000000)
     HaterPicPositions(4)=(X=362.000000,Y=729.000000)
     HaterPicPositions(5)=(X=10.000000,Y=10.000000)
     WritingSounds(0)=Sound'MiscSounds.Map.checkmark'
     WritingSounds(1)=Sound'MiscSounds.Map.CheckMark2'
     DudeGoHomeSounds(0)=Sound'DudeDialog.dude_timetogohome'
     DudeLostOnMap(0)=Sound'EASounds.DudeDialog.dude_designerfuckedup'
     DudeLostOnMap(1)=Sound'DudeDialog.dude_thatsclearly'
     DudeLostOnMap(2)=Sound'DudeDialog.dude_whoeverdesigned'
     DudeLostOnMap(3)=Sound'DudeDialog.dude_whydoesthisnot'
     MapPositions(0)=(UniqueTag="suburbs-1-ne",pos=(X=722.000000,Y=475.000000))
     MapPositions(1)=(UniqueTag="suburbs-1-sw",pos=(X=655.000000,Y=559.000000))
     MapPositions(2)=(UniqueTag="suburbs-2-n",pos=(X=681.000000,Y=619.000000))
     MapPositions(3)=(UniqueTag="suburbs-2-se",pos=(X=725.000000,Y=703.000000))
     MapPositions(4)=(UniqueTag="suburbs-3-ne",pos=(X=789.000000,Y=469.000000))
     MapPositions(5)=(UniqueTag="suburbs-3-sw",pos=(X=748.000000,Y=512.000000))
     MapPositions(6)=(UniqueTag="suburbs-4-nw",pos=(X=767.000000,Y=703.000000))
     MapPositions(7)=(UniqueTag="suburbs-4-c",pos=(X=815.000000,Y=754.000000))
     MapPositions(8)=(UniqueTag="forest-e",pos=(X=814.000000,Y=830.000000))
     MapPositions(9)=(UniqueTag="forest-w",pos=(X=772.000000,Y=824.000000))
     MapPositions(10)=(UniqueTag="parade-c",pos=(X=715.000000,Y=812.000000))
     MapPositions(11)=(UniqueTag="parade-e",pos=(X=739.000000,Y=813.000000))
     MapPositions(12)=(UniqueTag="rwsblock-n",pos=(X=642.000000,Y=263.000000))
     MapPositions(13)=(UniqueTag="rwsblock-s",pos=(X=730.000000,Y=394.000000))
     MapPositions(14)=(UniqueTag="westmall-nw",pos=(X=569.000000,Y=318.000000))
     MapPositions(15)=(UniqueTag="westmall-mid",pos=(X=568.000000,Y=354.000000))
     MapPositions(16)=(UniqueTag="eastmall-mid",pos=(X=577.000000,Y=379.000000))
     MapPositions(17)=(UniqueTag="eastmall-se",pos=(X=642.000000,Y=380.000000))
     MapPositions(18)=(UniqueTag="highlands-w",pos=(X=435.000000,Y=300.000000))
     MapPositions(19)=(UniqueTag="highlands-e",pos=(X=533.000000,Y=330.000000))
     MapPositions(20)=(UniqueTag="industry-n",pos=(X=529.000000,Y=395.000000))
     MapPositions(21)=(UniqueTag="industry-s",pos=(X=504.000000,Y=456.000000))
     MapPositions(22)=(UniqueTag="industry2-s",pos=(X=511.000000,Y=488.000000))
     MapPositions(23)=(UniqueTag="industry2-n",pos=(X=573.000000,Y=446.000000))
     MapPositions(24)=(UniqueTag="greenbelt1-n",pos=(X=465.000000,Y=574.000000))
     MapPositions(25)=(UniqueTag="greenbelt1-s",pos=(X=593.000000,Y=664.000000))
     MapPositions(26)=(UniqueTag="greenbelt2-n",pos=(X=468.000000,Y=420.000000))
     MapPositions(27)=(UniqueTag="greenbelt2-c",pos=(X=436.000000,Y=515.000000))
     MapPositions(28)=(UniqueTag="napalm-nw",pos=(X=392.000000,Y=459.000000))
     MapPositions(29)=(UniqueTag="napalm-se",pos=(X=426.000000,Y=505.000000))
     MapPositions(30)=(UniqueTag="compound-sw",pos=(X=558.000000,Y=254.000000))
     MapPositions(31)=(UniqueTag="compound-c",pos=(X=596.000000,Y=163.000000))
     MapPositions(32)=(UniqueTag="lib1",pos=(X=681.000000,Y=540.000000))
     MapPositions(33)=(UniqueTag="lib2",pos=(X=655.000000,Y=501.000000))
     MapPositions(34)=(UniqueTag="post1",pos=(X=831.000000,Y=766.000000))
     MapPositions(35)=(UniqueTag="post2",pos=(X=891.000000,Y=729.000000))
     MapPositions(36)=(UniqueTag="pol1",pos=(X=699.000000,Y=671.000000))
     MapPositions(37)=(UniqueTag="pol2",pos=(X=730.000000,Y=629.000000))
     MapPositions(38)=(UniqueTag="slaughter1",pos=(X=786.000000,Y=785.000000))
     MapPositions(39)=(UniqueTag="slaughter2",pos=(X=768.000000,Y=764.000000))
     MapPositions(40)=(UniqueTag="church-se",pos=(X=473.000000,Y=330.000000))
     MapPositions(41)=(UniqueTag="church-nw",pos=(X=402.000000,Y=226.000000))
     MapPositions(42)=(UniqueTag="brewery-se",pos=(X=533.000000,Y=366.000000))
     MapPositions(43)=(UniqueTag="brewery-nw",pos=(X=571.000000,Y=398.000000))
     MapPositions(44)=(UniqueTag="estates-n",pos=(X=788.000000,Y=318.000000))
     MapPositions(45)=(UniqueTag="estates-s",pos=(X=736.000000,Y=317.000000))
     MapPositions(46)=(UniqueTag="junkyard-nw",pos=(X=387.000000,Y=560.000000))
     MapPositions(47)=(UniqueTag="junkyard-se",pos=(X=431.000000,Y=634.000000))
}
