//=============================================================================
// 50AEAmmunition.
//=============================================================================
class AE50Ammunition extends P2AmmoInv;

var() class<DamageType> DesertEagleDamage;
var() class<DamageType> ZombieHeadDamage;

const FLESH_HIT_MAX	=	8;
var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local class<DamageType> ThisDamage;

	// reduce the ammo
	UseAmmoForShot();

	if ( Other == None )
		return;

	// Have to use IsA thanks to crummy compile order concerns
	if (W.IsA('DesertEagleWeapon'))
		ThisDamage = DesertEagleDamage;
	else
		ThisDamage = DamageTypeInflicted;
		
	if (ZombieHead(Other) != None)
		ThisDamage = ZombieHeadDamage;

	if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, ThisDamage);

		if((Pawn(Other) != None
				&& Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
				spawn(class'EDSplatterPack',Owner, ,HitLocation,Rotator(HitNormal));
		}
		else // anything else--make a spark hit
		{
			spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
			spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Add in the instigator
///////////////////////////////////////////////////////////////////////////////
function SpawnAE50Projectile(vector Start, vector Dir)
{
	local AE50Projectile np;

	AmmoAmount -= 1;
	np = AE50Projectile(spawn(ProjectileClass,Instigator,, Start));
	np.SetVelocity(Dir);
	//log(self$" spawned nine proj "$rp$" at "$np.Location$" player loc "$Instigator.Location$" speed "$np.Velocity$" rot "$Instigator.Rotation);



}

//===========================================================================
// DefaultProperties
//===========================================================================

defaultproperties
{
     DesertEagleDamage=Class'MaD_EDDamage.BerettaDamage'
//     DesertEagleDamage=Class'EAInventory.DesertEagleDamage'
     ZombieHeadDamage=Class'AWEffects.SledgeDamage'
     FleshHit(0)=Sound'ed_moresounds.Body.hit1'
     FleshHit(1)=Sound'ed_moresounds.Body.hit2'
     FleshHit(2)=Sound'ed_moresounds.Body.hit3'
     FleshHit(3)=Sound'ed_moresounds.Body.hit4'
     FleshHit(4)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(5)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(6)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(7)=Sound'WeaponSounds.bullet_hitflesh4'
     FleshRad=200.000000
     DamageAmount=80.000000
     MomentumHitMag=10000.000000
     DamageTypeInflicted=Class'MaD_EDDamage.BerettaDamage'
     AltDamageTypeInflicted=Class'EAInventory.AE50Damage'
     MaxAmmoMP=80
     MaxAmmo=200
     bLeadTarget=True
     bInstantHit=True
     ProjectileClass=Class'EAInventory.AE50Projectile'
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'EAInventory.AE50AmmoPickup'
     Texture=Texture'HUDPack.Icons.Icon_Weapon_Pistol'
}
