//=============================================================================
// AK47NoStockWeapon
// Copyright 2001 Running With Scissors, Inc.  All Rights Reserved.
//
// Machine gun weapon (first and third person).
//
// For AI characters, this weapon scales the number of times it's shot continuously
// with the difficulty level. Higher difficulty--more they shoot in one burst.
//
//	History:
//		01/29/02 MJR	Started history, probably won't be updated again until
//							the pace of change slows down.
//
//=============================================================================

class AK47NoStockWeapon extends AK47Weapon;

///////////////////////////////////////////////////////////////////////////////
// Vars, structs, consts
///////////////////////////////////////////////////////////////////////////////
var travel byte ShootScissors;		// Cheat that makes you shoot bouncing scissors instead
var float SPAccuracy;				// How accurate we are in single player games.

var AK47 AK;
var AK47Stock AKS;
var AK47Trigger AKT;
var AK47Magazine AKM;

simulated function PostNetBeginPlay()
{
    local PlayerController PC;
	local Pawn P;

    Super.PostNetBeginPlay();

    P  = Pawn(Owner);
	PC = PlayerController(P.Controller);

   	if (P.IsLocallyControlled() && PC!=None && (!PC.bBehindView) )
	{
	AK = Spawn(Class'EAInventory.AK47');
        	AttachToBone( AK, 'AK47' );
        	AKS = Spawn(Class'EAInventory.AK47Stock');
        	AttachToBone( AKS, 'AK47_Stock' );
	AKT = Spawn(Class'EAInventory.AK47Trigger');
        	AttachToBone( AKT, 'AK47_Trigger' );
	AKM = Spawn(Class'EAInventory.AK47Magazine');
        	AttachToBone( AKM, 'AK47_Magazine' );
    }
   	else
	{
        if(Instigator != None)
	   {
		 if(Instigator.Mesh != None)

             AK.Destroyed();
             AK = None;
             AKS.Destroyed();
             AKS = None;
             AKT.Destroyed();
             AKT = None;
             AKM.Destroyed();
             AKM = None;
	   }
	}

}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{

   Super.DropFrom(StartLocation);


             AK.Destroyed();
             AKS.Destroyed();
             AKT.Destroyed();
             AKM.Destroyed();

}

simulated function Destroyed()
{
   Super.Destroyed();

  if( AK != None )
  {
    DetachFromBone(AK);
    AK.Destroy();
    AK = None;
  }

  if( AKS != None )
  {
    DetachFromBone(AKS);
    AKS.Destroy();
    AKS = None;
  }

  if( AKT != None )
  {
    DetachFromBone(AKT);
    AKT.Destroy();
    AKT = None;
  }

  if( AKM != None )
  {
    DetachFromBone(AKM);
    AKM.Destroy();
    AKM = None;
  }
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     SPAccuracy=0.700000
     CatMesh=SkeletalMesh'EA_ClassicWeapons.FP_Dude_MachinegunCat'
     MFBloodTexture=Texture'nathans.muzzleflashes.bloodmuzzleflash'
     StartShotsWithCat=10
     CatFireSound=Sound'WeaponSounds.machinegun_catfire'
     ViolenceRank=5
     RecognitionDist=300.000000
     ShotCountMaxForNotify=20
     AI_BurstCountExtra=10
     AI_BurstCountMin=6
     AI_BurstTime=0.150000
     holdstyle=WEAPONHOLDSTYLE_Both
     switchstyle=WEAPONHOLDSTYLE_Both
     firingstyle=WEAPONHOLDSTYLE_Both
     MinRange=100.000000
     ShakeOffsetTime=2.000000
     CombatRating=5.000000
     FirstPersonMeshSuffix="MachineGun"
     WeaponSpeedLoad=1.500000
     WeaponSpeedReload=1.500000
     WeaponSpeedHolster=1.500000
     WeaponSpeedShoot1=4.000000
     AmmoName=Class'EAInventory.EA762mmAmmunation'
     AutoSwitchPriority=4
     ShakeRotMag=(X=120.000000,Y=30.000000,Z=30.000000)
     ShakeOffsetMag=(X=3.000000,Y=2.500000,Z=2.500000)
     TraceAccuracy=2.70000
     aimerror=600.000000
     AIRating=0.400000
     MaxRange=500.000000
     FireSound=Sound'EAWeaponsSounds.WeaponsFire.AK47_Fire'
     MuzzleScale=0.200000
     FlashOffsetY=-0.030000
     FlashOffsetX=0.030000
     MuzzleFlashSize=128.000000
     MFTexture=Texture'Timb.muzzle_flash.machine_gun_corona'
     bDrawMuzzleFlash=True
     MuzzleFlashScale=2.400000
     MuzzleFlashStyle=STY_Normal
     InventoryGroup=4
     GroupOffset=22
     PickupClass=Class'EAInventory.AK47NoStockPickup'
     PlayerViewOffset=(X=1.000000,Y=0.300000,Z=-1.300000)
     BobDamping=0.975000
     AttachmentClass=Class'EAInventory.AK47NoStockAttachment'
     ItemName="AK47 (No stock model)"
     Mesh=SkeletalMesh'EA_ClassicWeapons.FP_Dude_Machinegun'
     Skins(0)=Texture'WeaponSkins.Dude_Hands'
     Skins(1)=Shader'MaD_ED_Skins.AttachTex.FakeShad'
     Skins(2)=Texture'WeaponSkins.brass-01'
     Skins(3)=Texture'AnimalSkins.Cat_Orange'
     SoundRadius=255.000000
     Texture=Texture'EAWeaponsSkin.HUD.Icon_AK47_NoStock'
}
