// CatRocketGrenade
// Cat rockets shot by the grenade launcher in enhanced mode.
class CatRocketGrenade extends CatRocket;

const FORCE_RAD_CHECK		= 50;

var() float LifeTime;

simulated event PostBeginPlay()
{
	Super.PostBeginPlay();
	SetTimer(LifeTime, false);
}

simulated event Timer()
{
	GenExplosion(Location, Velocity, None);
}

///////////////////////////////////////////////////////////////////////////////
// Blow up and generate effects
///////////////////////////////////////////////////////////////////////////////
simulated function GenExplosion(vector HitLocation, vector HitNormal, Actor Other)
{
	local GrenadeExplosion exp;
	local vector WallHitPoint;

	if(Role == ROLE_Authority)
	{
		if(Other != None
			&& Other.bStatic)
		{
			// Make sure the force of this explosion is all the way against the wall that
			// we hit
			WallHitPoint = HitLocation - FORCE_RAD_CHECK*HitNormal;
			Trace(HitLocation, HitNormal, WallHitPoint, HitLocation);
		}
		else
			WallHitPoint = HitLocation;
		exp = spawn(class'GrenadeExplosion',GetMaker(),,HitLocation + ExploWallOut*HitNormal);
		exp.CheckForHitType(Other);
		exp.ShakeCamera(exp.ExplosionDamage);
		exp.ForceLocation = WallHitPoint;
	}
 	Destroy();
}

auto state Flying
{
	simulated function ProcessTouch (Actor Other, Vector HitLocation)
	{
		// Break through windows
		if(Window(Other) != None)
		{
			Other.Bump(self);
		}
		else if (Other != instigator) // explode on everything else
			GenExplosion(HitLocation,Normal(HitLocation-Other.Location), Other);
	}
}

defaultproperties
{
     Lifetime=30.000000
     bDoBounces=True
     LifeSpan=0.000000
     Skins(0)=Texture'AnimalSkins.Cat_Orange'
}
