//=============================================================================
// 5.56mmAmmunation.
//=============================================================================

class EA556mmAmmunation extends P2AmmoInv;

var() class<DamageType> M16A2Damage;
var() class<DamageType> M700Damage;
var() class<DamageType> ZombieHeadDamage;

const FLESH_HIT_MAX	=	8;
var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local class<DamageType> ThisDamage;

	// reduce the ammo
	UseAmmoForShot();

	if ( Other == None )
		return;

	// Have to use IsA thanks to crummy compile order concerns
	if (W.IsA('M16A2Weapon'))
		ThisDamage = M16A2Damage;
	else if (W.IsA('M4A1Weapon'))
		ThisDamage = M16A2Damage;
	else if (W.IsA('M700Weapon'))
		ThisDamage = M700Damage;
	else
		ThisDamage = DamageTypeInflicted;
		
	if (ZombieHead(Other) != None)
		ThisDamage = ZombieHeadDamage;

	if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'MachinegunBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
//		spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
//		spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, ThisDamage);

		if((Pawn(Other) != None
				&& Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
				spawn(class'EDSplatterPack',Owner, ,HitLocation,Rotator(HitNormal));
		}
		else // anything else--make a spark hit
		{
			spawn(class'BulletSparkPack',Owner, ,HitLocation, Rotator(HitNormal));
//			spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
//			spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Add in the instigator
///////////////////////////////////////////////////////////////////////////////
function SpawnEA556mmProjectile(vector Start, vector Dir)
{
	local EA556mmProjectile np;

	AmmoAmount -= 1;
	np = EA556mmProjectile(spawn(ProjectileClass,Instigator,, Start));
	np.SetVelocity(Dir);
	//log(self$" spawned 5.56 proj "$rp$" at "$np.Location$" player loc "$Instigator.Location$" speed "$np.Velocity$" rot "$Instigator.Rotation);



}

//===========================================================================
// DefaultProperties
//===========================================================================

defaultproperties
{
//     EAM16A2Damage=Class'MaD_EDDamage.BerettaDamage'
     M16A2Damage=Class'MaD_EDDamage.BerettaDamage'
     M4A1Damage=Class'MaD_EDDamage.BerettaDamage'
     M700Damage=Class'MaD_EDDamage.BerettaDamage'
     ZombieHeadDamage=Class'AWEffects.SledgeDamage'
     FleshHit(0)=Sound'ed_moresounds.Body.hit1'
     FleshHit(1)=Sound'ed_moresounds.Body.hit2'
     FleshHit(2)=Sound'ed_moresounds.Body.hit3'
     FleshHit(3)=Sound'ed_moresounds.Body.hit4'
     FleshHit(4)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(5)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(6)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(7)=Sound'WeaponSounds.bullet_hitflesh4'
     FleshRad=200.000000
     DamageAmount=20.000000
     MomentumHitMag=10000.000000
     AltDamageTypeInflicted=Class'MaD_EDDamage.BerettaDamage'
     DamageTypeInflicted=Class'MaD_EDDamage.BerettaDamage'
     MaxAmmoMP=200
     MaxAmmo=400
     bLeadTarget=True
     bInstantHit=True
     ProjectileClass=Class'EAInventory.EA556mmProjectile'
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'EAInventory.EA556mmAmmoPickup'
     Texture=Texture'HUDPack.Icons.Icon_Weapon_Machinegun'
}
