//=============================================================================
// 9mmAmmunation.
//=============================================================================

class EA9mmAmmunation extends P2AmmoInv;
//class EA9mmAmmunation extends NineAmmunition;

var() class<DamageType> GlockDamage;
var() class<DamageType> AkimboDamage;
var() class<DamageType> MP5Damage;
var() class<DamageType> IngramDamage;
var() class<DamageType> UZIDamage;
var() class<DamageType> BerettaDamage;
var() class<DamageType> ZombieHeadDamage;
var() class<DamageType> HeadDamage;					// Head shot damage

const FLESH_HIT_MAX	=	8;
var Sound FleshHit[FLESH_HIT_MAX];
var float FleshRad;

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local class<DamageType> ThisDamage;

	// reduce the ammo
	UseAmmoForShot();

	if ( Other == None )
		return;

	// Have to use IsA thanks to crummy compile order concerns
	if (W.IsA('EAGSelectWeapon'))
		ThisDamage = GlockDamage;

	else if (W.IsA('EAGlockAkimboWeapon'))
		ThisDamage = AkimboDamage;

	else if (W.IsA('PPKWeapon'))
		ThisDamage = GlockDamage;

	else if (W.IsA('PPKSilenceWeapon'))
		ThisDamage = GlockDamage;

	else if (W.IsA('PPKAkimboWeapon'))
		ThisDamage = AkimboDamage;

	else if (W.IsA('PPKAkimboSilenceWeapon'))
		ThisDamage = AkimboDamage;

	else if (W.IsA('EAMP5Weapon'))
		ThisDamage = MP5Damage;

	else if (W.IsA('EAIngramWeapon'))
		ThisDamage = IngramDamage;

	else if (W.IsA('UZIWeapon'))
		ThisDamage = UZIDamage;

	else if (W.IsA('EABerettaWeapon'))
		ThisDamage = BerettaDamage;
	else
		ThisDamage = DamageTypeInflicted;

	if (Head(Other) != None)
		ThisDamage = HeadDamage;

	if (ZombieHead(Other) != None)
		ThisDamage = ZombieHeadDamage;

	if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'PistolBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
//		spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
//		spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
	}
	else
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, ThisDamage);

		if((Pawn(Other) != None
				&& Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
				spawn(class'EDSplatterPack',Owner, ,HitLocation,Rotator(HitNormal));
		}
		else // anything else--make a spark hit
		{
			spawn(class'BulletSparkPack',Owner, ,HitLocation, Rotator(HitNormal));
//			spawn(class'EDGenericHitPack',Owner, ,HitLocation, Rotator(HitNormal));
//			spawn(class'MaDBulletHitPack',Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Add in the instigator
///////////////////////////////////////////////////////////////////////////////
function SpawnEA9mmProjectile(vector Start, vector Dir)
{
	local EA9mmProjectile np;

	AmmoAmount -= 1;
	np = EA9mmProjectile(spawn(ProjectileClass,Instigator,, Start));
	np.SetVelocity(Dir);
	//log(self$" spawned 9mm proj "$rp$" at "$np.Location$" player loc "$Instigator.Location$" speed "$np.Velocity$" rot "$Instigator.Rotation);



}

//===========================================================================
// DefaultProperties
//===========================================================================

defaultproperties
{
     GlockDamage=Class'BaseFX.BulletDamage'
     AkimboDamage=Class'BaseFX.BulletDamage'
     MP5Damage=Class'BaseFX.BulletDamage'
     IngramDamage=Class'BaseFX.BulletDamage'
     UZIDamage=Class'BaseFX.BulletDamage'
     BerettaDamage=Class'MaD_EDDamage.BerettaDamage'
//     HeadDamage=Class'BaseFX.RifleDamage'
     HeadDamage=Class'AWEffects.SledgeDamage'
     ZombieHeadDamage=Class'AWEffects.SledgeDamage'
     FleshHit(0)=Sound'ed_moresounds.Body.hit1'
     FleshHit(1)=Sound'ed_moresounds.Body.hit2'
     FleshHit(2)=Sound'ed_moresounds.Body.hit3'
     FleshHit(3)=Sound'ed_moresounds.Body.hit4'
     FleshHit(4)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(5)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(6)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(7)=Sound'WeaponSounds.bullet_hitflesh4'
     FleshRad=200.000000
     DamageAmount=10.000000
     MomentumHitMag=10000.000000
     AltDamageTypeInflicted=Class'BaseFX.BulletDamage'
     MaxAmmoMP=500
     MaxAmmo=1000
     bLeadTarget=True
     bInstantHit=True
     ProjectileClass=Class'EAInventory.EA9mmProjectile'
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'EAInventory.EA9mmAmmoPickup'
}
