class LaserWeapon extends P2Weapon;

var int AltShotCountMaxForNotify;
var Laser LS;
var LaserRing LSR;
var LaserCock LSC;

simulated function PostNetBeginPlay()
{
    local PlayerController PC;
	local Pawn P;

    Super.PostNetBeginPlay();

    P  = Pawn(Owner);
	PC = PlayerController(P.Controller);

   	if (P.IsLocallyControlled() && PC!=None && (!PC.bBehindView) )
	{
	LS = Spawn(Class'EAInventory.Laser');
        	LSR = Spawn(Class'EAInventory.LaserRing');
	LSC = Spawn(Class'EAInventory.LaserCock');
        	AttachToBone( LS, 'laser' );
        	AttachToBone( LSR, 'laser_ring' );
        	AttachToBone( LSC, 'laser_Cock' );
    }
   	else
	{
        if(Instigator != None)
	   {
		 if(Instigator.Mesh != None)

             LS.Destroyed();
             LS = None;
             LSR.Destroyed();
             LSR = None;
             LSC.Destroyed();
             LSC = None;
	   }
	}

}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{

   Super.DropFrom(StartLocation);


             LS.Destroyed();
             LSR.Destroyed();
             LSC.Destroyed();

}

simulated function Destroyed()
{
   Super.Destroyed();

  if( LS != None )
  {
    DetachFromBone(LS);
    LS.Destroy();
    LS = None;
  }

  if( LSR != None )
  {
    DetachFromBone(LSR);
    LSR.Destroy();
    LSR = None;
  }

  if( LSC != None )
  {
    DetachFromBone(LSC);
    LSC.Destroy();
    LSC = None;
  }
}


///////////////////////////////////////////////////////////////////////////////
// Called on client's side to make the gun fire
// Check here to throw out danger markers to let people know the gun has gone
// off.
///////////////////////////////////////////////////////////////////////////////
simulated function LocalFire()
{
	local P2Player P;
	
	bPointing = true;

	// Same as the one in P2Weapon, but we don't do the camera shake here
	// We make it shake when he throws

	if ( Affector != None )
		Affector.FireEffect();
	PlayFiring();
	if(Role < ROLE_Authority)
		GotoState('ClientFiring');
}		

simulated function PlayFiring()
{
	bForceReload=true;
	SetupMuzzleFlash();
	Super.PlayFiring();
}

///////////////////////////////////////////////////////////////////////////////
// Normal projectile fire, plus check where to make the danger marker to 
// alert people of the noise.
///////////////////////////////////////////////////////////////////////////////
function ProjectileFire()
{
	local vector markerpos, EndTrace;
	local vector StartTrace, X,Y,Z;

	// Moves like a projectile, but set up like a trace
	Owner.MakeNoise(1.0);
	GetAxes(Instigator.GetViewRotation(),X,Y,Z);
	StartTrace = GetFireStart(X,Y,Z); 
	AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 2*AimError);	
	EndTrace = StartTrace + (TraceAccuracy * (FRand() - 0.5 ) ) * Y * 1000
		+ (TraceAccuracy * (FRand() - 0.5 )) * Z * 1000;
	X = vector(AdjustedAim);
	EndTrace += (TraceDist * X); 

	// Make it
	LaserAmmoInv(AmmoType).SpawnLaserProjectile(StartTrace,Normal(EndTrace - StartTrace));
	
	// Only make a new danger marker if the consecutive fires were as high
	// as the max
	if(ShotCount >= ShotCountMaxForNotify
		&& Instigator.Controller != None
		&& ShotMarkerMade != None)
	{
		// tell it we know this just happened, by recording it.
		ShotCount -= ShotCountMaxForNotify;
		
		// Records the first (gun fire)
		markerpos = Instigator.Location;
		
		// Primary (the gun shooting, making a loud noise)
		if(ShotMarkerMade != None)
		{
			ShotMarkerMade.static.NotifyControllersStatic(
				Level,
				ShotMarkerMade,
				FPSPawn(Instigator), 
				None, 
				ShotMarkerMade.default.CollisionRadius,
				markerpos);
		}
	}
}

//////////////////////Silent-Scope Cocking action add/////////////////////////////////////////////////////////
simulated function Cock()
{
//	PlayAnim('ReloadMP', WeaponSpeedReload, 0.05);
	PlayAnim('ReloadDouble', WeaponSpeedReload, 0.05);
	
	P2MocapPawn(Instigator).PlayWeaponSwitch(self);
}

//////////////////////Silent-Scope Cocking action add/////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// This will randomly change the color and the size of the dynamic
// light associate with the flash. Change in each weapon's file,
// but call each time you start up the flash again.
// This function is also used by the third-person muzzle flash, so the
// colors will look the same
///////////////////////////////////////////////////////////////////////////////
simulated function PickLightValues()
{
	LightBrightness=150;
	LightSaturation=150;
	LightHue=12+FRand()*15;
	LightRadius=12+FRand()*6;
}

///////////////////////////////////////////////////////////////////////////////
// Make sure the muzzle flash renders, and move it around some
///////////////////////////////////////////////////////////////////////////////
simulated function SetupMuzzleFlash()
{
	bMuzzleFlash = true;
	bSetFlashTime = false;
	// Gets turned off in weapon, in RenderOverlays
	// Slightly change colors each time
	if(IsFirstPersonView()
		&& bDrawMuzzleFlash)
	{
		PickLightValues();
		bDynamicLight=bAllowDynamicLights;
	}
}


///////////////////////////////////////////////////////////////////////////////
// See what we hit
///////////////////////////////////////////////////////////////////////////////
function TraceFire( float Accuracy, float YOffset, float ZOffset )
{
	local int i;
	local PersonController perc;
	local vector dir;

	ProjectileFire();
	// Reduce the ammo only by 1 here, for the shotgun, but shoot
	// ShotCountMaxForNotify number of pellets each time.
//	P2AmmoInv(AmmoType).UseAmmoForShot();
	perc = PersonController(Instigator.Controller);
}


state ClientFiring
{
}

state NormalFire
{
}

function Notify_ShootSMEG()
{
//	ProjectileFire();
}

function ShootSMEG()
{
}

simulated function Notify_RatchetSound()
{
	Instigator.PlayOwnedSound(ReloadSound, SLOT_Misc, 1.0);
}

///////////////////////////////////////////////////////////////////////////////
// play reloading sounds
///////////////////////////////////////////////////////////////////////////////
simulated function PlayReloading()
{
	// temp speed up because with no animation, you can't tell you're
	// why you can't shoot (becuase it's playing a reload anim)
	PlayAnim('Load', WeaponSpeedReload, 0.05);
}

///////////////////////////////////////////////////////////////////////////////
// Skin changing START Silent-Scope      BOOOOYA
///////////////////////////////////////////////////////////////////////////////


         function Notify_skinflash_start()
         {
}

///////////////////////////////////////////////////////////////////////////////
// Skin Changing END Silent-Scope  BOOOYA
///////////////////////////////////////////////////////////////////////////////

          function Notify_skinflash_end()
         {
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     ViolenceRank=4
     RecognitionDist=1100.000000
     ReloadSound=Sound'Zombification.Weapons.mp5clipin'
     ShotMarkerMade=None
     BulletHitMarkerMade=Class'Postal2Game.BulletHitMarker'
     holdstyle=WEAPONHOLDSTYLE_Double
     switchstyle=WEAPONHOLDSTYLE_Double
     firingstyle=WEAPONHOLDSTYLE_Double
     MinRange=200.000000
     ShakeOffsetTime=2.500000
     CombatRating=4.000000
     WeaponsPackageStr="EA_Weapons."
     WeaponSpeedLoad=1.500000
     WeaponSpeedHolster=1.500000
     WeaponSpeedShoot1Rand=0.300000
     WeaponSpeedShoot2=0.250000
     WeaponSpeedShoot2Rand=0.300000
     WeaponSpeedIdle=0.800000
//     AltFireSound=Sound'WeaponSounds.shotgun_fire'
     AmmoName=Class'EAInventory.LaserAmmoInv'
     AutoSwitchPriority=5
     ShakeRotMag=(X=400.000000)
     ShakeRotTime=2.500000
     ShakeOffsetMag=(X=0.000000,Y=0.000000,Z=0.000000)
     TraceAccuracy=0.00000
     aimerror=400.000000
     AIRating=0.300000
     MaxRange=512.000000
     FireSound=Sound'EAWeaponsSounds.GoldenEye.GE_LaserFire'
     SelectSound=Sound'EAWeaponsSounds.GoldenEye.GE_Laser'
     FlashOffsetY=-0.050000
     FlashOffsetX=0.060000
     FlashLength=0.050000
     MuzzleFlashSize=128.000000
     MFTexture=Shader'EAWeaponsSkin.Effect.Muzzle_Laser'
     bDrawMuzzleFlash=True
     MuzzleFlashScale=2.400000
     MuzzleFlashStyle=STY_Normal
     InventoryGroup=2
     GroupOffset=32
     PickupClass=Class'EAInventory.LaserPickup'
     BobDamping=0.975000
     AttachmentClass=Class'EAInventory.LaserAttachment'
     ItemName="Laser"
     Texture=Texture'EAWeaponsSkin.HUD.Icon_Laser'
     Mesh=SkeletalMesh'EA_Weapons.ED_SMEG_newest'
     Skins(0)=Shader'MaD_ED_Skins.AttachTex.FakeShad'
     Skins(1)=Texture'WeaponSkins.Dude_Hands'
     SoundRadius=255.000000
     AmbientGlow=0
}
