//=============================================================================
// M16A2Weapon
//=============================================================================

class M16A2Weapon extends M16A2ReloaderWeapon;

///////////////////////////////////////////////////////////////////////////////
// Vars, structs, consts
///////////////////////////////////////////////////////////////////////////////
var travel byte ShootScissors;		// Cheat that makes you shoot bouncing scissors instead
var float SPAccuracy;				// How accurate we are in single player games.
var P2Pawn MyTarget;

var float myValue;



///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// NormalFire
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state NormalFire
{

	///////////////////////////////////////////////////////////////////////////////
	// When necessary, handle the full screen alpha change
	///////////////////////////////////////////////////////////////////////////////
	simulated function Tick(float DeltaTime)
	{
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// ClientFiring
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state ClientFiring
{
	///////////////////////////////////////////////////////////////////////////////
	// When necessary, handle the full screen alpha change
	///////////////////////////////////////////////////////////////////////////////
	simulated function Tick(float DeltaTime)
	{
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function PostBeginPlay()
{
	local float diffoffset;

	Super.PostBeginPlay();

	// If it's a single player game, make our accuracy much worse
	if(Level.Game != None
		&& FPSGameInfo(Level.Game).bIsSinglePlayer)
	{
		TraceAccuracy = SPAccuracy;

		// Based on the difficulty, bump up the number of times AI will continuously
		// shoot this weapon
		diffoffset = P2GameInfo(Level.Game).GetDifficultyOffset();
		if(diffoffset > 0)
		{
			AI_BurstCountExtra+=diffoffset;
		}
	}
}

function Notify_Fire()
{
   ProjectileFire();
   SetupMuzzleFlash();
   Instigator.PlaySound(FireSound, SLOT_Misc, 1.0);
   AmbientGlow=400;
}

///////////////////////////////////////////////////////////////////////////////
// Play firing animation/sound/etc
///////////////////////////////////////////////////////////////////////////////
simulated function PlayNewFiring()
{
	// Play MP sounds on everyone's computers
	if(Level.Game == None
		|| !FPSGameInfo(Level.Game).bIsSinglePlayer)
		PlayOwnedSound(FireSound,SLOT_Interact,1.0,,,WeaponFirePitchStart + (FRand()*WeaponFirePitchRand),false);
		


	else // just on yours in SP games
		Instigator.PlaySound(FireSound, SLOT_None, 1.0, true, , WeaponFirePitchStart + (FRand()*WeaponFirePitchRand));
	PlayAnim('Shoot1', WeaponSpeedShoot1 + (WeaponSpeedShoot1Rand*FRand()), 0.05);
}

///////////////////////////////////////////////////////////////////////////////
// Don't allow them to shoot as the rifle is brightening up
///////////////////////////////////////////////////////////////////////////////
simulated function Fire( float Value )
{

myValue = Value;

        	Super.Fire(Value);
        
}

///////////////////////////////////////////////////////////////////////////////
// Called on client's side to make the gun fire
// Check here to throw out danger markers to let people know the gun has gone
// off.
///////////////////////////////////////////////////////////////////////////////
simulated function LocalFire()
{
	local P2Player P;
	
	bPointing = true;

	// Same as the one in P2Weapon, but we don't do the camera shake here
	// We make it shake when he throws

	if ( Affector != None )
		Affector.FireEffect();
	PlayFiring();

        if(Role < ROLE_Authority)
		GotoState('ClientFiring');
		
		
}

///////////////////////////////////////////////////////////////////////////////
// Normal projectile fire, plus check where to make the danger marker to
// alert people of the noise.
///////////////////////////////////////////////////////////////////////////////
function ProjectileFire()
{

	local vector markerpos, EndTrace;
	local vector StartTrace, X,Y,Z;

	// Moves like a projectile, but set up like a trace
	Owner.MakeNoise(1.0);
	GetAxes(Instigator.GetViewRotation(),X,Y,Z);
	StartTrace = GetFireStart(X,Y,Z);
	AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 1*AimError);
	EndTrace = StartTrace + (TraceAccuracy * (FRand() - 0.5 ) ) * Y * 1000
		+ (TraceAccuracy * (FRand() - 0.5 )) * Z * 1000;
	X = vector(AdjustedAim);
	EndTrace += (TraceDist * X);

        // Make it
	EA556mmAmmunation(AmmoType).SpawnEA556mmProjectile(StartTrace,Normal(EndTrace - StartTrace));

	// Only make a new danger marker if the consecutive fires were as high
	// as the max
	if(ShotCount >= ShotCountMaxForNotify
		&& Instigator.Controller != None
		&& ShotMarkerMade != None)
	{
		// tell it we know this just happened, by recording it.
		ShotCount -= ShotCountMaxForNotify;

		// Records the first (gun fire)
		markerpos = Instigator.Location;

		// Primary (the gun shooting, making a loud noise)
		if(ShotMarkerMade != None)
		{
			ShotMarkerMade.static.NotifyControllersStatic(
				Level,
				ShotMarkerMade,
				FPSPawn(Instigator),
				None,
				ShotMarkerMade.default.CollisionRadius,
				markerpos);
		}
	}
}
state Streaming
{
	ignores PrevWeapon, NextWeapon, WeaponChange, Fire, ServerFire;
//	ignores PrevWeapon, NextWeapon, WeaponChange;

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function bool PutDown()
	{
		bChangeWeapon = true;
		return True;
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function AnimEnd(int Channel)
	{
		// If it's the guy playing that hosts the listen server
		// or it's a typical client/stand alone game.
		if(NotDedOnServer())
		{
			if(Instigator.PressingFire()
				&& AmmoType.HasAmmo())
			{



                                PlayFiring();

                                //dopamine - Not only play the animation, but fire a fucking bullet for Gods sake
                                ProjectileFire();

                                //dopamine, have to call this for the semi fire to count reloads
                                Serverfire();
                                


                                reloadcount-=3;  //reloadcount--;

                                if (reloadcount <= 0)
                                {
//				     EndStreaming();
//				     ServerEndStreaming();
			        }

			}
			else
			{
//				EndStreaming();
//				ServerEndStreaming();
			}
		}
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function EndState()
	{
		Instigator.AmbientSound = None;
		//log(self$" end streaming");
	}

	///////////////////////////////////////////////////////////////////////////////
	// Set to seeking when you get to this state
	///////////////////////////////////////////////////////////////////////////////
	simulated function BeginState()
	{
		PlayFiring();
		
		                                //dopamine - Not only play the animation, but fire a fucking bullet for Gods sake
                                ProjectileFire();

                                //dopamine, have to call this for the semi fire to count reloads
                                Serverfire();
                                
                                                                reloadcount-=3;  //reloadcount--;

                                if (reloadcount <= 0)
                                {
//				     EndStreaming();
//				     ServerEndStreaming();
			        }
		

	}
}
///////////////////////////////////////////////////////////////////////////////
// Tell ammo to make this scissors type
///////////////////////////////////////////////////////////////////////////////
function SpawnScissors(bool bMakeSpinner)
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;
	local ScissorsProjectile sic;
	local P2Player p2p;
	
	GetAxes(Instigator.GetViewRotation(),X,Y,Z);
	StartTrace = GetFireStart(X,Y,Z); 
	AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 2*AimError);	
	sic = spawn(class'ScissorsAltProjectile',Instigator,,StartTrace, AdjustedAim);
}

///////////////////////////////////////////////////////////////////////////////
// See what we hit
///////////////////////////////////////////////////////////////////////////////
function TraceFire( float Accuracy, float YOffset, float ZOffset )
{
	local int i;
	
	// Reduce the ammo only by 1 here, for the shotgun, but shoot
	// ShotCountMaxForNotify number of pellets each time.
//	P2AmmoInv(AmmoType).UseAmmoForShot();

	// Reduce the cat ammo if we're using one
	if(CatOnGun == 1)
		CatAmmoLeft--;

	if(ShootScissors==1)
		SpawnScissors(true);
	else
		Super.TraceFire(Accuracy, YOffset, ZOffset);
}

///////////////////////////////////////////////////////////////////////////////
// DrawMuzzleFlash()
//Default implementation assumes that flash texture can be drawn inverted in X and/or Y direction to increase apparent
//number of flash variations
// We might need to draw a dark blood splat
///////////////////////////////////////////////////////////////////////////////
simulated function DrawMuzzleFlash(Canvas Canvas)
{
	local float Scale, ULength, VLength, UStart, VStart;

	// Form dynamic muzzle flash size
	MuzzleScale = FRand()*(default.MuzzleScale);
	// Form offset based on that
//	FlashOffsetX = -(MuzzleScale/500) + default.FlashOffsetX;
//	FlashOffsetY = -(MuzzleScale/500) + default.FlashOffsetY;

	MuzzleScale += 1.0;

	if(CatOnGun == 0
		|| !class'P2Player'.static.BloodMode())
		Super.DrawMuzzleFlash(Canvas);
	else	// if a cat, then draw it alpha blended with a gross blood splat
	{
		Scale = MuzzleScale * Canvas.ClipX/640.0;
		Canvas.Style = ERenderStyle.STY_Alpha;
		ULength = MFTexture.USize;
		if ( FRand() <= 0.5 )
		{
			UStart = ULength;
			ULength = -1 * ULength;
		}
		VLength = MFTexture.VSize;
		if ( FRand() <= 0.5 )
		{
			VStart = VLength;
			VLength = -1 * VLength;
		}

		Canvas.DrawTile(MFTexture, Scale * MFTexture.USize, Scale * MFTexture.VSize, 
					UStart, VStart, ULength, VLength);
		Canvas.Style = ERenderStyle.STY_Normal;
	}
}
simulated function PlayReloading()
	{
        P2MocapPawn(Instigator).PlayWeaponReload(self);
        	
        PlayAnim('Reload', WeaponSpeedReload, 0.05);

	Instigator.PlaySound(ReloadSound, SLOT_Misc, 1.0);
	}


///////////////////////////////////////////////////////////////////////////////
// This will randomly change the color and the size of the dynamic
// light associate with the flash. Change in each weapon's file,
// but call each time you start up the flash again.
// This function is also used by the third-person muzzle flash, so the
// colors will look the same
///////////////////////////////////////////////////////////////////////////////
simulated function PickLightValues()
{
	LightBrightness=150;
	LightSaturation=150;
	LightHue=12+FRand()*15;
	LightRadius=12+FRand()*6;
}

///////////////////////////////////////////////////////////////////////////////
// Make sure the muzzle flash renders, and move it around some
///////////////////////////////////////////////////////////////////////////////
simulated function SetupMuzzleFlash()
{
	bMuzzleFlash = true;
	bSetFlashTime = false;
	// Gets turned off in weapon, in RenderOverlays
	// Slightly change colors each time
	if(IsFirstPersonView()
		&& bDrawMuzzleFlash)
	{
		PickLightValues();
		bDynamicLight=bAllowDynamicLights;
	}
}

///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Skin changing START Silent-Scope      BOOOOYA
///////////////////////////////////////////////////////////////////////////////


         function Notify_skinflash_start()
         {
                  AmbientGlow=400;
}

///////////////////////////////////////////////////////////////////////////////
// Skin Changing END Silent-Scope  BOOOYA
///////////////////////////////////////////////////////////////////////////////

          function Notify_skinflash_end()
         {
                 AmbientGlow=0;
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     SPAccuracy=0.700000
     CatMesh=SkeletalMesh'EA_ClassicWeapons.FP_Dude_MachinegunCat'
     MFBloodTexture=Texture'nathans.muzzleflashes.bloodmuzzleflash'
     StartShotsWithCat=5
     CatFireSound=Sound'WeaponSounds.machinegun_catfire'
     ViolenceRank=5
     RecognitionDist=300.000000
     ShotCountMaxForNotify=3
     holdstyle=WEAPONHOLDSTYLE_Both
     switchstyle=WEAPONHOLDSTYLE_Both
     firingstyle=WEAPONHOLDSTYLE_Both
     MinRange=300.000000
     ShakeOffsetTime=2.000000
     CombatRating=5.000000
     FirstPersonMeshSuffix="FP_Dude_Machinegun"
     WeaponsPackageStr="EA_ClassicWeapons."
     WeaponSpeedLoad=1.000000
     WeaponSpeedReload=1.000000
     WeaponSpeedHolster=1.000000
     WeaponSpeedShoot1=1.000000
     WeaponSpeedShoot1Rand=0.020000
     AmmoName=Class'EAInventory.EA556mmAmmunation'
     ReloadCount=30
     AutoSwitchPriority=9
     ShakeRotMag=(X=120.000000,Y=30.000000,Z=30.000000)
     ShakeOffsetMag=(X=20.000000,Y=2.500000,Z=2.500000)
     TraceAccuracy=0.20000
     aimerror=600.000000
     AIRating=0.400000
     MaxRange=300.000000
//     FireSound=Sound'WeaponSounds.Machinegun_fire'
     FireSound=Sound'EAWeaponsSounds.WeaponsFire.M16A2_Fire'
     MessageNoAmmo="M16A2 has no ammo."
     MuzzleScale=0.200000
     FlashOffsetY=-0.030000
     FlashOffsetX=0.030000
     MuzzleFlashSize=128.000000
     MFTexture=Texture'Timb.muzzle_flash.machine_gun_corona'
     bDrawMuzzleFlash=True
     MuzzleFlashScale=2.400000
     MuzzleFlashStyle=STY_Normal
     InventoryGroup=4
     GroupOffset=21
     PickupClass=Class'EAInventory.M16A2Pickup'
     PlayerViewOffset=(X=1.000000,Y=0.300000,Z=-1.300000)
     BobDamping=0.975000
     AttachmentClass=Class'Inventory.MachinegunAttachment'
     ItemName="Colt M16A2"
     Mesh=SkeletalMesh'EA_ClassicWeapons.FP_Dude_Machinegun'
     Skins(0)=Texture'WeaponSkins.Dude_Hands'
     Skins(1)=Texture'WeaponSkins.m-16_timb'
     Skins(2)=Texture'WeaponSkins.brass-01'
     Skins(3)=Texture'AnimalSkins.Cat_Orange'
     Texture=Texture'HUDPack.Icons.Icon_Weapon_Machinegun'
     SoundRadius=255.000000
     AmbientGlow=0
}
