///////////////////////////////////////////////////////////////////////////////
// M870BulletAmmoInv
// Copyright 2001 Running With Scissors, Inc.  All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////

class M870BulletAmmoInv extends P2AmmoInv;


var travel int CatAmmoLeft;		// How many shots we've taken with the cat, when this reaches
								// 0, the cat shoots off
var int ShotsWithCat;			// total shots we get with a cat, probably 9 for 9 lives
var float FleshRad;
var Sound FleshHit[4];
var() class<DamageType> ZombieHeadDamage;

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;

	if ( Other == None )
		return;

	if (Other.bStatic)//Other.bWorldGeometry ) 
	{
		spawn(class'ShotgunBulletHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
	}
	else 
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);

		if((Pawn(Other) != None && Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			if(Rand(2) == 0)
				Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
		}
		else // anything else--make a spark hit
		{
			spawn(class'BulletSparkPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     ZombieHeadDamage=Class'AWEffects.SledgeDamage'
     FleshRad=200.000000
     FleshHit(0)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(1)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(2)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(3)=Sound'WeaponSounds.bullet_hitflesh4'
     DamageAmount=11.000000
     MomentumHitMag=200000.000000
     DamageTypeInflicted=Class'BaseFX.ShotGunDamage'
//     DamageTypeInflicted=Class'EAInventory.M870Damage'
     DamageAmountMP=16.000000
     MaxAmmoMP=20
     MaxAmmo=60
     bLeadTarget=True
     bInstantHit=True
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'EAInventory.M870AmmoPickup'
     Texture=Texture'HUDPack.Icons.Icon_Weapon_Shotgun'
}
