class NukeWeapon extends LauncherWeapon;

function bool ValidTarget(FPSPawn TestTarget)
{
	return false;
}

simulated function AltFire( float Value );
function ServerAltFire();

///////////////////////////////////////////////////////////////////////////////
// Skip the charge, go straight to the fire
///////////////////////////////////////////////////////////////////////////////
simulated function Fire( float Value )
{
	if ( AmmoType == None
		|| !AmmoType.HasAmmo() )
	{
		ClientForceFinish();
		ServerForceFinish();
		return;
	}


	bAltFiring=false;
	ShootIt();
	ClientShootIt();
	//ServerFire();
}
/*
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function ServerFire()
{
	PlayFiring();
	LocalFire();
	ClientPlayFiring();
	ShootIt();
	ClientShootIt();
}*/

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function Notify_ShootLauncher()
{
	local vector StartTrace, X,Y,Z, markerpos, HitNormal, HitLocation;
	local actor HitActor;
	local NukeProjectile lpro;
	//local MPNukeSeekingProjectileTrad lspro;
	local float giveback;

	if(AmmoType != None)
	{
		GetAxes(Instigator.GetViewRotation(),X,Y,Z);
		StartTrace = GetFireStart(X,Y,Z); 
		AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 2*AimError);
		//CalcAIChargeTime();
		ShootStyleChanger=0;
		// Make sure we're not generating this on the other side of a thin wall
		//if(FastTrace(Instigator.Location, StartTrace))
		HitActor = Trace(HitLocation, HitNormal, Instigator.Location, StartTrace, true);
		if(HitActor == None
			|| (!HitActor.bStatic
				&& !HitActor.bWorldGeometry))
		{
			/*if(!bSeeking)
				// fire a normal rocket
			{*/
				lpro = spawn(class'NukeProjectile',Instigator,,StartTrace, AdjustedAim);
				if(lpro != None)
				{
					ChargeTime=30;
					lpro.Instigator = Instigator;
					// Compensate for catnip time, if necessary. Don't do this for NPCs
					if(FPSPawn(Instigator) != None
						&& FPSPawn(Instigator).bPlayer)
						ChargeTime /= Level.TimeDilation;
					lpro.SetupShot(ChargeTime);
					lpro.AddRelativeVelocity(Instigator.Velocity);
					// Touch any actor that was in between, just in case.
					if(HitActor != None)
						HitActor.Bump(lpro);
				}
			/*}
			else // fire a seeking rocket
			{
				// Shoot either a traditional seeking rocket or a new super seeker
				if(!bShootTradSeeker)
					lspro = spawn(class'MPNukeSeekingProjectile',Instigator,,StartTrace, AdjustedAim);
				else
					lspro = spawn(class'MPNukeSeekingProjectileTrad',Instigator,,StartTrace, AdjustedAim);

				if(lspro != None)
				{
					lspro.Instigator = Instigator;

					// if we're not aimed at anything, figure out a target
					if(CurrentTarget == None)
					{
						lspro.DetermineTarget(ProjectedHitLoc);
					}
					else
						lspro.SetNewTarget(CurrentTarget);

					lspro.SetupShot(SeekingChargeMultiplier*ChargeTime);

					lspro.AddRelativeVelocity(Instigator.Velocity);

					// Touch any actor that was in between, just in case.
					if(HitActor != None)
						HitActor.Bump(lspro);
				}
			}*/
		}

		// Clear our target regardless
		//CurrentTarget = None;
		// If we didn't make a valid rocket, then give him his ammo back
		if(lpro != None)
			//&& lspro == None)
		/*{
			giveback = ChargeStartAmmo - AmmoType.AmmoAmount;
			if(giveback > 0)
				AmmoType.AddAmmo(giveback);
		}
		else*/
		{
			// Say we just fired
			ShotCount++;
			P2AmmoInv(AmmoType).UseAmmoForShot(1);

			// Only make a new danger marker if the consecutive fires were as high
			// as the max
			if(ShotCount >= ShotCountMaxForNotify
				&& Instigator.Controller != None
				&& ShotMarkerMade != None)
			{
				// tell it we know this just happened, by recording it.
				ShotCount -= ShotCountMaxForNotify;
				
				// Records the first (gun fire)
				markerpos = Instigator.Location;
				
				// Primary (the gun shooting, making a loud noise)
				if(ShotMarkerMade != None)
				{
					ShotMarkerMade.static.NotifyControllersStatic(
						Level,
						ShotMarkerMade,
						FPSPawn(Instigator), 
						None, 
						ShotMarkerMade.default.CollisionRadius,
						markerpos);
				}
			}
		}
		// Reset the ammo you started with
		//ChargeStartAmmo = AmmoType.AmmoAmount;
	}
}

defaultproperties
{
     bUsesAltFire=False
     ViolenceRank=15
     MinRange=2048.000000
     HudHint1="Point and shoot this miniature nuke.  "
     HudHint2="Just try not to blow your dumb ass up."
     AmmoName=Class'EAInventory.NukeAmmoInv'
     MaxRange=4196.000000
     FireSound=Sound'WeaponSounds.napalm_fire'
     GroupOffset=1
     PickupClass=Class'EAInventory.NukePickup'
     AttachmentClass=Class'EAInventory.NukeAttachment'
     ItemName="Mini-Nuke Launcher"
     Texture=Texture'EATex.Icons.hud_Nuke'
     Skins(0)=Texture'MP_FPArms.LS_arms.LS_hands_dude'
     Skins(1)=Texture'EATex.Weapons.NukeLauncher_nomips'
     Skins(2)=Texture'EATex.Weapons.Trifoil'
     Skins(3)=Texture'EATex.Weapons.Trifoil'
     SoundRadius=255.000000
     AmbientGlow=0
}
