///////////////////////////////////////////////////////////////////////////////
// PPK Akimbo Silence Attachment EDITED by Silent-Scope
///////////////////////////////////////////////////////////////////////////////
class PPKAkimboSilenceAttachment extends P2WeaponAttachment;

var bool bAkimboGun;
var PPKAkimboSilenceXAttachment TwinGun;

replication
{
	reliable if ( Role == ROLE_Authority && bNetInitial)
		bAkimboGun, TwinGun;
}

///////////////////////////////////////////////////////////////////////////////
// Akimbo Style
///////////////////////////////////////////////////////////////////////////////
function PostBeginPlay()
{
       TwinGun = Spawn(Class'PPKAkimboSilenceXAttachment');
       Instigator.AttachToBone(TwinGun, 'MALE01 L Hand');
       bAkimboGun = true;

	Super.PostBeginPlay();
}


simulated function Destroyed()
{
   Super.Destroyed();

  if( TwinGun != None )
  {
    Instigator.DetachFromBone(TwinGun);
    TwinGun.Destroy();
    TwinGun = None;
  }
}

simulated event ThirdPersonEffects()
{
	Super.ThirdPersonEffects();

	if (MuzzleFlash3rd!=None)
	{
		MuzzleFlash3rd.Flash();

		if ( !bAkimboGun && (TwinGun != None) )
				TwinGun.MuzzleFlash3rd.Flash();

		// Play MP sounds on everyone's computers
		if(FireSound != None
			&& MuzzleFlash3rd.GetStateName() == 'Visible'
			&& (Level.Game == None
				|| !FPSGameInfo(Level.Game).bIsSinglePlayer))
			Instigator.PlaySound(FireSound, SLOT_None, 1.0, true, TransientSoundRadius, GetRandPitch());
	}
}

defaultproperties
{
//     MuzzleFlashClass=Class'Inventory.PistolMuzzleFlash'
     MuzzleOffset=(X=32.000000,Z=5.000000)
     WeapClass=Class'EAInventory.PPKAkimboSilenceWeapon'
     FireSound=Sound'EAWeaponsSounds.GoldenEye.GE_Silencer'
     FiringMode="AKIMBO1"
     DrawType=DT_StaticMesh
     StaticMesh=StaticMesh'EAWeaponsMesh.3rdPerson.TP_PPK_Silence'
}
