class SmegAmmoInv extends P2AmmoInv;

var float FleshRad;
var Sound FleshHit[4];

///////////////////////////////////////////////////////////////////////////////
// Process a trace hitting something
///////////////////////////////////////////////////////////////////////////////
function ProcessTraceHit(Weapon W, Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local Rotator NewRot;
	local PersonController perc;

	if ( Other == None )
		return;

	perc = PersonController(Instigator.Controller);

	if (P2Weapon(W).bAltFiring || (perc != None && perc.Target != None && perc.MyPawn.bAdvancedFiring))
	{
		if (P2GameInfoSingle(Level.Game).VerifySeqTime() && Pawn(Owner).Controller.bIsPlayer)
			spawn(class'MolotovExplosion', W.Owner,, HitLocation, Rotator(HitNormal));
		else
			spawn(class'SMEGMiniExplosion', W.Owner,, HitLocation, Rotator(HitNormal));
	}
	else if (Other.bStatic)//Other.bWorldGeometry )
	{
		spawn(class'PistolBulletHitPack',W.Owner, ,HitLocation, Rotator(HitNormal));
	}
	else 
	{
		Other.TakeDamage(DamageAmount, Pawn(Owner), HitLocation, MomentumHitMag*X, DamageTypeInflicted);

		if((Pawn(Other) != None && Other != Owner)
			|| PeoplePart(Other) != None
			|| CowheadProjectile(Other) != None)
		{
			if(Rand(2) == 0)
				Other.PlaySound(FleshHit[Rand(ArrayCount(FleshHit))],SLOT_Pain,,,FleshRad,GetRandPitch());
		}
		else // anything else--make a spark hit
		{
			spawn(class'BulletSparkPack',W.Owner, ,HitLocation, Rotator(HitNormal));
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     FleshRad=200.000000
     FleshHit(0)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(1)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(2)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(3)=Sound'WeaponSounds.bullet_hitflesh4'
     DamageAmount=20.000000
     MomentumHitMag=120000.000000
     DamageTypeInflicted=Class'MaD_EDDamage.GaugeDamage'
     DamageAmountMP=12.000000
     MaxAmmoMP=20
     MaxAmmo=30
     bLeadTarget=True
     bInstantHit=True
     WarnTargetPct=0.200000
     RefireRate=0.990000
     PickupClass=Class'EAInventory.SmegAmmoPickup'
     Texture=Texture'EATex.Icons.hud_SMEG'
}
