///////////////////////////////////////////////////////////////////////////////
// GrenadeExplosion
// 
// explosion for a grenade
///////////////////////////////////////////////////////////////////////////////
class StunGrenadeExplosion extends P2Explosion;

var bool bGroundHit;
const	FIRE_INDEX	=	0;
const	DIRT_INDEX	=	1;
const	DUST_INDEX	=	2;
const	BLOOD_INDEX	=	3;
var Sound  GrenadeExplodeAir;
var Sound  GrenadeExplodeGround;
var StunGrenadeExplodeFlash myFlash;


replication
{
	// server sends this to client if enough bandwidth 
	unreliable if(Role==ROLE_Authority)
		ClientMakeBlood, ClientMakeAir;
}
function Tick(float DeltaTime)
{
	CheckHurtRadius(ExplosionDamage, ExplosionRadius, MyDamageType, ExplosionMag, ForceLocation);
}

///////////////////////////////////////////////////////////////////////////////
// Perhaps do something special if you hit a wall
///////////////////////////////////////////////////////////////////////////////
function CheckForHitType(Actor Other)
{
	local vector endpt;

	// Make bloody explosion
	if(Pawn(Other) != None)
	{
		ClientMakeBlood();
	}
	else
	{
		endpt = Location;
		endpt.z -= CollisionRadius;
		if(FastTrace(endpt, Location))
		// We *didn't* hit ground, so turn *off* dirt effects
		{
			ClientMakeAir();
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function ClientMakeAir()
{
	Emitters[DIRT_INDEX].Disabled=true;
	Emitters[DUST_INDEX].Disabled=true;
	bGroundHit=false;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function ClientMakeBlood()
{
	Emitters[DIRT_INDEX].Disabled=true;
	Emitters[DUST_INDEX].Disabled=true;
	// Only if we allow blood
	if(class'P2Player'.static.BloodMode())
		Emitters[BLOOD_INDEX].Disabled=false;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
auto state Exploding
{
Begin:
	if(bGroundHit)
 		PlaySound(GrenadeExplodeGround,,1.0,,,,true);
	else
		PlaySound(GrenadeExplodeAir,,1.0,,,,true);
	Sleep(DelayToHurtTime);


        myFlash = spawn(class'StunGrenadeExplodeFlash',Instigator);///,,StartTrace, AdjustedAim);

	CheckHurtRadius(ExplosionDamage, ExplosionRadius, MyDamageType, ExplosionMag, Location);
	NotifyPawns();
}

defaultproperties
{
     bGroundHit=True
     GrenadeExplodeAir=Sound'EAWeaponsSounds.WeaponsFire.StunGrenade_Explode'
     GrenadeExplodeGround=Sound'EAWeaponsSounds.WeaponsFire.StunGrenade_Explode'
     ExplosionMag=0.000000
     ExplosionDamage=2.000000
     ExplosionRadius=800.000000
     MyDamageType=Class'BaseFX.ElectricalDamage'
     Begin Object Class=SpriteEmitter Name=SpriteEmitter246
         MaxParticles=7
         RespawnDeadParticles=False
         StartLocationRange=(X=(Min=-30.000000,Max=30.000000),Y=(Min=-30.000000,Max=30.000000),Z=(Min=-30.000000,Max=30.000000))
         SpinParticles=True
         SpinsPerSecondRange=(X=(Max=0.100000))
         StartSpinRange=(X=(Max=1.000000))
         UseSizeScale=True
         UseRegularSizeScale=False
         SizeScale(1)=(RelativeTime=0.100000,RelativeSize=0.700000)
         SizeScale(2)=(RelativeTime=1.000000,RelativeSize=1.000000)
         StartSizeRange=(X=(Min=600.000000,Max=700.000000))
         InitialParticlesPerSecond=100.000000
         AutomaticInitialSpawning=False
         DrawStyle=PTDS_AlphaBlend
         Texture=Texture'nathans.Skins.expl1'
         TextureUSubdivisions=1
         TextureVSubdivisions=4
         BlendBetweenSubdivisions=True
         SecondsBeforeInactive=0.000000
         LifetimeRange=(Min=5.000000,Max=8.500000)
         StartVelocityRange=(X=(Min=-300.000000,Max=300.000000),Y=(Min=-300.000000,Max=300.000000),Z=(Min=-100.000000,Max=100.000000))
         VelocityLossRange=(X=(Min=2.000000,Max=2.000000),Y=(Min=2.000000,Max=2.000000),Z=(Min=2.000000,Max=2.000000))
         Name="SpriteEmitter246"
     End Object
     Emitters(0)=SpriteEmitter'EAInventory.SpriteEmitter246'
     Begin Object Class=SpriteEmitter Name=SpriteEmitter227
         Acceleration=(Z=-600.000000)
         MaxParticles=20
         RespawnDeadParticles=False
         StartLocationRange=(X=(Min=-30.000000,Max=30.000000),Y=(Min=-30.000000,Max=30.000000),Z=(Min=-30.000000,Max=30.000000))
         SpinParticles=True
         SpinsPerSecondRange=(X=(Max=2.000000))
         StartSpinRange=(X=(Max=1.000000))
         UseSizeScale=True
         UseRegularSizeScale=False
         SizeScale(0)=(RelativeSize=1.000000)
         SizeScale(1)=(RelativeTime=1.000000)
         StartSizeRange=(X=(Min=5.000000,Max=15.000000))
         InitialParticlesPerSecond=300.000000
         AutomaticInitialSpawning=False
         DrawStyle=PTDS_AlphaBlend
         Texture=Texture'nathans.Skins.blast1'
         TextureUSubdivisions=1
         TextureVSubdivisions=2
         UseRandomSubdivision=True
         SecondsBeforeInactive=0.000000
         LifetimeRange=(Min=5.000000,Max=6.00000)
         StartVelocityRange=(X=(Min=-600.000000,Max=600.000000),Y=(Min=-600.000000,Max=600.000000),Z=(Max=500.000000))
         Name="SpriteEmitter227"
     End Object
     Emitters(1)=SpriteEmitter'EAInventory.SpriteEmitter227'
     Begin Object Class=SpriteEmitter Name=SpriteEmitter329
         UseDirectionAs=PTDU_Up
         Acceleration=(Z=-1.000000)
         UseColorScale=True
         ColorScale(0)=(Color=(B=100,G=120,R=160))
         ColorScale(1)=(RelativeTime=0.200000,Color=(B=100,G=100,R=128))
         ColorScale(2)=(RelativeTime=1.000000,Color=(B=100,G=100,R=128))
         FadeOut=True
         MaxParticles=12
         RespawnDeadParticles=False
         StartLocationRange=(X=(Min=-20.000000,Max=20.000000),Y=(Min=-20.000000,Max=20.000000),Z=(Min=-50.000000,Max=-20.000000))
         UseSizeScale=True
         UseRegularSizeScale=False
         SizeScale(1)=(RelativeTime=0.300000,RelativeSize=0.700000)
         SizeScale(2)=(RelativeTime=1.000000,RelativeSize=1.000000)
         StartSizeRange=(X=(Max=200.000000),Y=(Min=200.000000,Max=400.000000))
         InitialParticlesPerSecond=3000.000000
         AutomaticInitialSpawning=False
         DrawStyle=PTDS_AlphaModulate_MightNotFogCorrectly
         Texture=Texture'nathans.Skins.pour2'
         SecondsBeforeInactive=0.000000
         LifetimeRange=(Min=5.200000,Max=7.700000)
         StartVelocityRange=(X=(Min=-400.000000,Max=400.000000),Y=(Min=-400.000000,Max=400.000000),Z=(Min=220.000000,Max=320.000000))
         VelocityLossRange=(X=(Min=1.500000,Max=1.500000),Y=(Min=1.500000,Max=1.500000),Z=(Min=1.500000,Max=1.500000))
         Name="SpriteEmitter329"
     End Object
     Emitters(2)=SpriteEmitter'EAInventory.SpriteEmitter329'
     Begin Object Class=SpriteEmitter Name=SpriteEmitter448
         Acceleration=(Z=-600.000000)
         MaxParticles=20
         RespawnDeadParticles=False
         Disabled=True
         StartLocationRange=(X=(Min=-3.000000,Max=3.000000),Y=(Min=-3.000000,Max=3.000000),Z=(Min=-3.000000,Max=3.000000))
         SpinParticles=True
         SpinsPerSecondRange=(X=(Max=2.000000))
         StartSpinRange=(X=(Max=1.000000))
         UseSizeScale=True
         UseRegularSizeScale=False
         SizeScale(0)=(RelativeSize=1.000000)
         SizeScale(1)=(RelativeTime=1.000000)
         StartSizeRange=(X=(Min=5.000000,Max=35.000000))
         InitialParticlesPerSecond=300.000000
         AutomaticInitialSpawning=False
         DrawStyle=PTDS_AlphaBlend
         Texture=Texture'nathans.Skins.bloodchunks1'
         TextureUSubdivisions=1
         TextureVSubdivisions=4
         UseRandomSubdivision=True
         SecondsBeforeInactive=0.000000
         LifetimeRange=(Min=1.000000,Max=1.000000)
         StartVelocityRange=(X=(Min=-300.000000,Max=300.000000),Y=(Min=-300.000000,Max=300.000000),Z=(Max=500.000000))
         Name="SpriteEmitter448"
     End Object
     Emitters(3)=SpriteEmitter'EAInventory.SpriteEmitter448'
     AutoDestroy=True
     LifeSpan=5.000000
     TransientSoundRadius=600.000000
}
