//=============================================================================
// UZIWeapon EDITED By Silent-Scope
// Copyright 2001 Running With Scissors, Inc.  All Rights Reserved.
//
// Pistol weapon (first and third person).
//
// For AI characters, this weapon scales the number of times it's shot continuously
// with the difficulty level. Higher difficulty--more they shoot in one burst.
//
//	History:
//		07/22/03 NPF	Fires faster per click only in single player. In MP, it
//						fires faster just by holding down the fire button.
//
//		01/11/03 NPF	Allowed pistol to fire faster than firing animation
//						normally permits, if player clicks Fire again. 
//
//		01/29/02 MJR	Started history, probably won't be updated again until
//							the pace of change slows down.
//
//
//=============================================================================

class UZIWeapon extends IngramReloaderWeapon;



var bool bCanFireAgain;		// If you're the player and this is set to true, then you
							// shoot again if even you're still in NormalFire
// var float LaserSightSize;
var float WeaponSpeedShoot1MP;	// Allow faster shooting in multiplayer.
var float SPAccuracy;				// How accurate we are in single player games.
var UZI UZ;
var UZIMagazine UZM;
var UZICock UZC;
var UZITrigger UZT;

const FIRING_WAIT_TIME = 0.4;

//dopamine
var float WeaponSpeedPrep, WeaponSpeedEnd;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function PostBeginPlay()
{
	local float diffoffset;

	Super.PostBeginPlay();

	// If it's a single player game, make our accuracy much worse
	if(Level.Game != None
		&& FPSGameInfo(Level.Game).bIsSinglePlayer)
	{
		TraceAccuracy = SPAccuracy;

		// Based on the difficulty, bump up the number of times AI will continuously
		// shoot this weapon
		diffoffset = P2GameInfo(Level.Game).GetDifficultyOffset();
		if(diffoffset > 0)
		{
			AI_BurstCountExtra+=(diffoffset/2);
		}
	}
}

simulated function PostNetBeginPlay()
{
    local PlayerController PC;
	local Pawn P;

    Super.PostNetBeginPlay();

    P  = Pawn(Owner);
	PC = PlayerController(P.Controller);

   	if (P.IsLocallyControlled() && PC!=None && (!PC.bBehindView) )
	{
	UZ = Spawn(Class'EAInventory.UZI');
        	UZM = Spawn(Class'EAInventory.UZIMagazine');
	UZC = Spawn(Class'EAInventory.UZICock');
        	UZT = Spawn(Class'EAInventory.UZITrigger');
        	AttachToBone( UZ, 'UZI_Grip' );
        	AttachToBone( UZM, 'UZI_Mag' );
        	AttachToBone( UZC, 'UZI_Cock' );
        	AttachToBone( UZT, 'UZI_Trigger' );
    }
   	else
	{
        if(Instigator != None)
	   {
		 if(Instigator.Mesh != None)

             UZ.Destroyed();
             UZ = None;
             UZM.Destroyed();
             UZM = None;
             UZC.Destroyed();
             UZC = None;
             UZT.Destroyed();
             UZT = None;
	   }
	}

}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{

   Super.DropFrom(StartLocation);


             UZ.Destroyed();
             UZM.Destroyed();
             UZC.Destroyed();
             UZT.Destroyed();

}

simulated function Destroyed()
{
   Super.Destroyed();

  if( UZ != None )
  {
    DetachFromBone(UZ);
    UZ.Destroy();
    UZ = None;
  }

  if( UZM != None )
  {
    DetachFromBone(UZM);
    UZM.Destroy();
    UZM = None;
  }

  if( UZC != None )
  {
    DetachFromBone(UZC);
    UZC.Destroy();
    UZC = None;
  }

  if( UZT != None )
  {
    DetachFromBone(UZT);
    UZT.Destroy();
    UZT = None;
  }
}


///////////////////////////////////////////////////////////////////////////////
// Fire the weapon
///////////////////////////////////////////////////////////////////////////////
simulated function PlayFiring()
	{
	// Basics
	IncrementFlashCount();
	if(Level.Game == None
		|| !FPSGameInfo(Level.Game).bIsSinglePlayer)
	{
		// Play your sound in MP in your attachment to save bandwidth
		PlayAnim('Shoot1', WeaponSpeedShoot1MP + (WeaponSpeedShoot1Rand*FRand()), 0.05);
	}
	else
	{
		Instigator.PlaySound(FireSound, SLOT_None, 1.0, true, , WeaponFirePitchStart + (FRand()*WeaponFirePitchRand));
		PlayAnim('Shoot1', WeaponSpeedShoot1 + (WeaponSpeedShoot1Rand*FRand()), 0.05);
	}

	// Adv.
	SetupMuzzleFlash();
	// Once the player started his fire, don't let it fire again
	// until the sleep in the NormalFire state let's him
	if(PlayerController(Instigator.Controller) != None)
		bCanFireAgain=false;
	}

///////////////////////////////////////////////////////////////////////////////
// This will randomly change the color and the size of the dynamic
// light associate with the flash. Change in each weapon's file,
// but call each time you start up the flash again.
// This function is also used by the third-person muzzle flash, so the 
// colors will look the same
///////////////////////////////////////////////////////////////////////////////
simulated function PickLightValues()
{
	LightBrightness=150;
	LightSaturation=150;
	LightHue=12+FRand()*15;
	LightRadius=12+FRand()*6;
}

///////////////////////////////////////////////////////////////////////////////
// Make sure the muzzle flash renders, and move it around some
///////////////////////////////////////////////////////////////////////////////
simulated function SetupMuzzleFlash()
{
	bMuzzleFlash = true;
	bSetFlashTime = false;
	// Gets turned off in weapon, in RenderOverlays
	// Slightly change colors each time
	if(IsFirstPersonView()
		&& bDrawMuzzleFlash)
	{
		PickLightValues();
		bDynamicLight=bAllowDynamicLights;
	}
}

///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Skin changing START Silent-Scope      BOOOOYA
///////////////////////////////////////////////////////////////////////////////


         function Notify_skinflash_start()
         {
       AmbientGlow=400;
}




///////////////////////////////////////////////////////////////////////////////
// Skin Changing END Silent-Scope  BOOOYA
///////////////////////////////////////////////////////////////////////////////


          function Notify_skinflash_end()
         {
      AmbientGlow=0;
}






///////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// NormalFire
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state NormalFire
{


}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// ClientFiring
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state ClientFiring
{

}

/////////////////////////////////
///////////////////////////
////////////////////////DOPAMINE

simulated function PrepStreaming()
{
	// play our intro stream anim
	PlayStreamStart();
	if(!bDelayedStartSound)
		Instigator.PlaySound(soundStart, SLOT_None, 1.0, false, 1000.0, 1.0);
}

simulated function PlayStreamStart()
	{

    //    if (bZoomed)
                PlayAnim('Shoot1Prep', WeaponSpeedIdle, 0.0);

	}
simulated function PlayStreamEnd()
	{

  //      if (bZoomed)
             PlayAnim('Shoot1End', WeaponSpeedIdle, 0.0);

	}








state StartStream
{
	ignores Fire, ServerFire, AltFire;

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function AnimEnd(int Channel)
	{
		//log(self$" going to streaming");
		GotoState('Streaming');
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function BeginState()
	{
		//log(self$" startstream");
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Streaming
// 'Fire' this weapon in a looping fashion, till it's done
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state Streaming
{
	ignores PrevWeapon, NextWeapon, WeaponChange, Fire, ServerFire, AltFire;

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function bool PutDown()
	{
		bChangeWeapon = true;
		return True;
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function AnimEnd(int Channel)
	{
		// If it's the guy playing that hosts the listen server
		// or it's a typical client/stand alone game.
		if(NotDedOnServer())
		{
			if(Instigator.PressingFire()
				&& AmmoType.HasAmmo())
			{



                                PlayFiring();

                                //dopamine - Not only play the animation, but fire a fucking bullet for Gods sake
                                ProjectileFire();

                                //dopamine, have to call this for the semi fire to count reloads
                                Serverfire();


			}
			else
			{
				EndStreaming();
				ServerEndStreaming();
			}
		}
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function EndState()
	{
		Instigator.AmbientSound = None;
		//log(self$" end streaming");
	}

	///////////////////////////////////////////////////////////////////////////////
	// Set to seeking when you get to this state
	///////////////////////////////////////////////////////////////////////////////
	simulated function BeginState()
	{
		PlayFiring();
	}
Begin:
	if(!bDelayedStartSound)
		Instigator.AmbientSound = soundLoop1;
	else
	{
		Instigator.PlaySound(soundStart, SLOT_None, 1.0, false, 1000.0, 1.0);
		Sleep(Instigator.GetSoundDuration(soundStart));
		Instigator.AmbientSound = soundLoop1;
	}
}

simulated function PlayReloading()
	{
        P2MocapPawn(Instigator).PlayWeaponReload(self);
        	
        PlayAnim('Reload', WeaponSpeedReload, 0.05);

	Instigator.PlaySound(ReloadSound, SLOT_Misc, 1.0);
	}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

/*
///////////////////////////////////////////////////////////////////////////////
// Laser Sight Code - ADDED by Nial
///////////////////////////////////////////////////////////////////////////////

function Tick(float DeltaTime)
{
        TraceSight(TraceAccuracy,0,0);
}

///////////////////////////////////////////////////////////////////////////////
// Rewritten TraceSight routine. I'll add a brief explanation here incase anyone
// ever picks up the old code and tries to make some use of it. Basically, all I do
// here is take the first object the player's Trace hits as OTHER and work out the
// VSIZE between Location (of player) and LastHitLocation (of trace) to get the
// distance between PLAYER > OBJECT
///////////////////////////////////////////////////////////////////////////////
function TraceSight( float Accuracy, float YOffset, float ZOffset )
	{
	local vector HitNormal, StartTrace, EndTrace, X,Y,Z, sumtot;
	local actor Other;
	local float sumtot2;

	//Owner.MakeNoise(1.0);
	GetAxes(Instigator.GetViewRotation(),X,Y,Z);
	StartTrace = GetFireStart(X,Y,Z);
	AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 2*AimError);
	EndTrace = StartTrace + (YOffset + Accuracy * (FRand() - 0.5 ) ) * Y * 1000
		+ (ZOffset + Accuracy * (FRand() - 0.5 )) * Z * 1000;
	X = vector(AdjustedAim);
	EndTrace += (TraceDist * X);

	Other = Trace(LastHitLocation,HitNormal,EndTrace,StartTrace,True);
    sumtot2 = (VSize((Location - LastHitLocation)) / 256);
    LaserSightSize = (sumtot2 / 40);
   	}

///////////////////////////////////////////////////////////////////////////////
// A messy DrawCrossHair hack that lets us resize the CrossHair according to a
// variable. I tried Dynamic Projection and it didn't work, so this seemed the next
// logical step!
///////////////////////////////////////////////////////////////////////////////

simulated function DrawCrossHair( canvas Canvas)
{
	local float XLength, PickDiff;

	XLength = 0.10 - LaserSightSize;

	if (XLength < 0.01) { XLength = 0.01; }
	if (XLength > 0.06) { XLength = 0.06; }

	Canvas.bNoSmooth = False;
	Canvas.SetPos(0.503 * (Canvas.ClipX - (XLength * 256)), 0.504 * (Canvas.ClipY - (XLength * 256)));
	Canvas.SetDrawColor(255,255,255);
	Canvas.DrawIcon(Texture'ED_Weaponskins.Reticule.Ingram_ret', XLength);
	Canvas.bNoSmooth = True;
	Canvas.Style = Style;
}



 */

///////////////////////////////////////////////////////////////////////////////
// EndStream
//////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state EndStream
{
	ignores Fire;

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function AnimEnd(int Channel)
	{
		GotoState('Idle');
	}

	///////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////
	simulated function BeginState()
	{
		// play our intro stream anim
		PlayStreamEnd();
		Instigator.PlaySound(soundEnd, SLOT_None, 1.0, false, 1000.0, 1.0);
	}
}

//Function for each shot
function Notify_Fire()
{
   ProjectileFire();
   SetupMuzzleFlash();
   Instigator.PlaySound(FireSound, SLOT_Misc, 1.0);
   AmbientGlow=400;
}
///////////////////////////////////////////////////////////////////////////////
// Normal projectile fire, plus check where to make the danger marker to
// alert people of the noise.
///////////////////////////////////////////////////////////////////////////////
function ProjectileFire()
{

	local vector markerpos, EndTrace;
	local vector StartTrace, X,Y,Z;



	// Moves like a projectile, but set up like a trace
	Owner.MakeNoise(1.0);
	GetAxes(Instigator.GetViewRotation(),X,Y,Z);
	StartTrace = GetFireStart(X,Y,Z);
	AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 2*AimError);
	EndTrace = StartTrace + (TraceAccuracy * (FRand() - 0.5 ) ) * Y * 1000
		+ (TraceAccuracy * (FRand() - 0.5 )) * Z * 1000;
	X = vector(AdjustedAim);
	EndTrace += (TraceDist * X);

        // Make it
	EA9mmAmmunation(AmmoType).SpawnEA9mmProjectile(StartTrace,Normal(EndTrace - StartTrace));

	// Only make a new danger marker if the consecutive fires were as high
	// as the max
	if(ShotCount >= ShotCountMaxForNotify
		&& Instigator.Controller != None
		&& ShotMarkerMade != None)
	{
		// tell it we know this just happened, by recording it.
		ShotCount -= ShotCountMaxForNotify;

		// Records the first (gun fire)
		markerpos = Instigator.Location;

		// Primary (the gun shooting, making a loud noise)
		if(ShotMarkerMade != None)
		{
			ShotMarkerMade.static.NotifyControllersStatic(
				Level,
				ShotMarkerMade,
				FPSPawn(Instigator),
				None,
				ShotMarkerMade.default.CollisionRadius,
				markerpos);
		}
	}
	



}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     bCanFireAgain=True
     WeaponSpeedShoot1=30.000000
     WeaponSpeedShoot1MP=30.000000
     SPAccuracy=0.700000
     WeaponSpeedPrep=1.000000
     WeaponSpeedEnd=1.000000
     RecognitionDist=100.000000
     AI_BurstCountExtra=3
     AI_BurstTime=0.800000
     ShotMarkerMade=Class'Postal2Game.GunfireMarker'
     BulletHitMarkerMade=Class'Postal2Game.BulletHitMarker'
     holdstyle=WEAPONHOLDSTYLE_Single
     switchstyle=WEAPONHOLDSTYLE_Single
     firingstyle=WEAPONHOLDSTYLE_Single
     ReticleTexture=Texture'ED_WeaponSkins.Reticule.Ingram_ret'
     MinRange=20.000000
     ShakeOffsetTime=2.200000
     CombatRating=3.000000
     FirstPersonMeshSuffix="ED_Ingram_NEW"
     WeaponsPackageStr="ED_Weapons."
     WeaponSpeedShoot1Rand=8.040000
//     AmmoName=Class'EAInventory.EA9mmAmmunation'
     AmmoName=Class'EAInventory.UZIAmmoInv'
     ReloadCount=50
     TraceAccuracy=2.20000
     aimerror=4.000000
     AIRating=0.200000
     MaxRange=20.000000
     FireSound=Sound'EAWeaponsSounds.WeaponsFire.UZI_Fire'
     FlashOffsetY=0.150000
     FlashOffsetX=0.215000
     FlashLength=0.010000
     MuzzleFlashSize=128.000000
     MFTexture=Texture'Timb.muzzle_flash.pistol_corona'
     MuzzleFlashScale=2.400000
     MuzzleFlashStyle=STY_Normal
     AutoSwitchPriority=6
     ViolenceRank=3
     InventoryGroup=4
     GroupOffset=20
     PickupClass=Class'EAInventory.UZIPickup'
     PlayerViewOffset=(X=0.000000,Z=-1.300000)
     BobDamping=0.975000
     AttachmentClass=Class'EAInventory.UZIAttachment'
     ItemName="UZI 9mm"
     Texture=Texture'EAWeaponsSkin.HUD.Icon_UZI'
     Mesh=SkeletalMesh'EA_Weapons.ED_Ingram_NEW'
     Skins(0)=Texture'MP_FPArms.LS_arms.LS_hands_dude'
     Skins(1)=Texture'ED_WeaponSkins.Pistol.beretta'
     Skins(2)=Shader'MaD_ED_Skins.AttachTex.FakeShad'
     AmbientGlow=0
     SoundRadius=255.000000
}
