class WardrobeInv extends ClothesInv;

var array<class> WardSkins;
var bool bShortSleeves;

state Activated
{
	///////////////////////////////////////////////////////////////////////////////
	// Setup a swap of our current clothes out for these
	///////////////////////////////////////////////////////////////////////////////
	function StartChangeClothes()
	{
		local P2Player p2p;
		local P2Pawn CheckPawn;
		local class OurClass;

		if(Owner != None)
		{
			p2p = P2Player(Pawn(Owner).Controller);

			if(p2p != None)
			{
				// See if we can change our clothes
				OurClass=WardSkins[Rand(WardSkins.Length)];
				if(p2p.CheckForChangeClothes(class<Inventory>(OurClass)))
				{
					TurnOffHints();	// When you use it, turn off the hints

					p2p.SayTime = 0;
					ChangeWorked(p2p);
					WaitTime = p2p.SayTime;
					GotoState('Activated', 'DoChange');
					return;
				}
			}
		}
		GotoState('Activated', 'Failed');
	}
}

defaultproperties
{
     WardSkins(0)=Class'EAInventory.wHomoClothes'
     WardSkins(1)=Class'EAInventory.wBandClothes'
     WardSkins(2)=Class'EAInventory.wBookClothes'
     WardSkins(3)=Class'EAInventory.wBumClothes'
     WardSkins(4)=Class'EAInventory.wZealotClothes'
     WardSkins(5)=Class'EAInventory.wFanaticClothes'
     WardSkins(6)=Class'EAInventory.wMcDClothes'
     WardSkins(7)=Class'EAInventory.wHippyClothes'
     WardSkins(8)=Class'EAInventory.wGangsterClothes'
     WardSkins(9)=Class'EAInventory.wMallworkerClothes'
     WardSkins(10)=Class'EAInventory.wMeatClothes'
     WardSkins(11)=Class'EAInventory.wRedneckClothes'
     WardSkins(12)=Class'EAInventory.wRWSClothes'
     WardSkins(13)=Class'EAInventory.wScientistClothes'
     WardSkins(14)=Class'EAInventory.wButcherClothes'
     WardSkins(15)=Class'EAInventory.wPriestClothes'
     HudSplats(0)=Texture'nathans.Inventory.bloodsplat-1'
     HudSplats(1)=Texture'nathans.Inventory.bloodsplat-2'
     HudSplats(2)=Texture'nathans.Inventory.bloodsplat-3'
     Hint1="Use this to change clothes at random!"
     Hint2="Try it out in front of a mirror and see"
     Hint3="what you can get!"
     PickupClass=Class'EAInventory.WardrobePickup'
     Icon=Texture'EATex.Icons.hud_wardrobe'
}
