//=============================================================================
// MaDMaceWeapon.
// Created on: 04/05/2005
// Written by Eduard Klemens
// Mail to: madjackal_x@hotmail.com.
//  2005, MaD Inc. All Rights Reserved.
//=============================================================================
class MaDMaceWeapon extends ShovelWeapon;

#exec OBJ LOAD FILE=EAMaDModsAnims.ukx

var MaDMace MMace;

simulated function PostNetBeginPlay()
{
    local PlayerController PC;
	local Pawn P;

    Super.PostNetBeginPlay();

    P  = Pawn(Owner);
	PC = PlayerController(P.Controller);

   	if (P.IsLocallyControlled() && PC!=None && (!PC.bBehindView) )
	{
        MMace = Spawn(Class'EAInventory.MaDMace');
        AttachToBone(MMace, 'Basey');
    }
   	else
	{
        if(Instigator != None)
	   {
		 if(Instigator.Mesh != None)

             MMace.Destroyed();
             MMace = None;
	   }
	}

}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function DropFrom(vector StartLocation)
{

   Super.DropFrom(StartLocation);


     MMace.Destroyed();

}

simulated function Destroyed()
{
   Super.Destroyed();

  if( MMace != None )
  {
    DetachFromBone(MMace);
    MMace.Destroy();
    MMace = None;
  }
}

simulated function PlayFiring()
{
    Instigator.PlaySound(FireSound, SLOT_None, 1.0, true, , WeaponFirePitchStart + (FRand()*WeaponFirePitchRand));
	Super.PlayFiring();

}
simulated function PlayAltFiring()
{
    Instigator.PlaySound(AltFireSound, SLOT_None, 1.0, true, , WeaponFirePitchStart + (FRand()*WeaponFirePitchRand));
	Super.PlayAltFiring();

}


///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     RecognitionDist=600.000000
     AI_BurstCountExtra=2
     AI_BurstTime=1.000000
     switchstyle=WEAPONHOLDSTYLE_Single
     ShakeOffsetTime=3.000000
     PlayerMeleeDist=100.000000
     NPCMeleeDist=90.000000
     HudHint2="Alt Fire (Right Mouse Button) to bash."
     CombatRating=1.000000
     FirstPersonMeshSuffix="Baton"
     WeaponSpeedLoad=1.250000
     WeaponSpeedShoot1=0.900000
     WeaponSpeedShoot1Rand=0.200000
     WeaponSpeedShoot2=0.900000
     WeaponSpeedIdle=0.300000
     AltFireSound=Sound'EAMaDModsSounds.MaDMace_Swing01'
     AmmoName=Class'EAInventory.MaDMaceInv'
     FireOffset=(X=2.000000,Z=-1.000000)
     ShakeRotMag=(X=30.000000,Y=250.000000,Z=30.000000)
     ShakeRotTime=3.000000
     ShakeOffsetMag=(X=0.000000,Y=6.000000,Z=0.000000)
     TraceAccuracy=0.100000
     AIRating=0.100000
     MaxRange=90.000000
     FireSound=Sound'EAMaDModsSounds.MaDMace_swing00'
     SelectSound=Sound'EAMaDModsSounds.MaDMaceSelect'
     GroupOffset=8
     PickupClass=Class'EAMaDMods.MaDMacePickup'
     PlayerViewOffset=(X=1.000000)
     BobDamping=0.975000
     AttachmentClass=Class'EAInventory.MaDMaceAttachment'
     ItemName="M@D Mace"
     Mesh=SkeletalMesh'EAMaDModsAnims.MaD_LS_Basey'
     Skins(0)=Texture'MP_FPArms.LS_arms.LS_hands_dude'
}
