class DeadLimbMarker extends DeadBodyMarker;

///////////////////////////////////////////////////////////////////////////////
// Tell the controllers i've been made
///////////////////////////////////////////////////////////////////////////////
function NotifyControllers()
{
	local FPSPawn CheckP;
	local LambController lambc;
	local P2Player p2p;
	local bool bPlayerNear;

//	log(self@"NotifyControllers start");

	// If our pawn died, kill ourselves
	if(OriginActor == None)
	{
//		log(self@"OriginActor is none, destroying self");
		Destroy();
	}
	else
	{
	// Kamek edit
//    	log(self@"iterating through colliding pawns WITHOUT notifying -- crash debugging purposes");
//		ForEach CollidingActors(class'FPSPawn', CheckP, CollisionRadius, OriginActor.Location)
//		{
//			log(self@"Found pawn"@CheckP@"with controller"@CheckP.Controller@"bDeleteMe"@CheckP.bDeleteMe);
//		}
//		log(self@"finished interim check of pawns, now doing the real deal.");
//		log(self@"ForEach CollidingActors of class FPSPawn within radius"@CollisionRadius@"at location"@OriginActor.Location);
		ForEach CollidingActors(class'FPSPawn', CheckP, CollisionRadius, OriginActor.Location)
		{
//			log(self@"checking pawn"@CheckP@"with controller"@CheckP.Controller@"bDeleteMe"@CheckP.bDeleteMe);
			if (CheckP.Controller != None && !CheckP.Controller.bDeleteMe)
			{
				// call the appropriate controller
//				log(self@"notifying controller of pawn"@CheckP);
				lambc = LambController(CheckP.Controller);
//				log(self@"LambController is"@lambc);
				if(lambc != None
					&& CheckP != CreatorPawn
					&& CheckP != OriginActor)
				{
//					log(self@"informing"@lambc@"of danger");
					lambc.MarkerIsHere(class, CreatorPawn, OriginActor, OriginActor.Location);
//					log(self@"finished informing"@lambc@"of danger");
				}
				else
				{
//					log(self@"No lamb controller or checkp is possibly a player");

                    if(CheckP.bPlayer)
					{
//						log(self@"CheckP is a player; setting bPlayerNear");
						bPlayerNear=true;
					}

//	                log(self@"getting P2Player of CheckP controller");
					p2p = P2Player(CheckP.Controller);
//	                log(self@"p2p is"@p2p);
					if(p2p != None)
					{
//						log(self@"informing player of danger here");
						p2p.MarkerIsHere(class, CreatorPawn, OriginActor, OriginActor.Location);
//						log(self@"done informing player");
					}
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Tell the controllers i've been made
///////////////////////////////////////////////////////////////////////////////
static function NotifyControllersStatic(LevelInfo UseLevel,
										class<TimedMarker> UseClass,
										FPSPawn CheckCreatorPawn,
										Actor CheckOriginActor,
										float UseCollisionRadius,
										vector Loc)
{
	local FPSPawn CheckP;
	local LambController lambc;
	local P2Player p2p;
	local bool bPlayerNear;

	ForEach UseLevel.CollidingActors(class'FPSPawn', CheckP, UseCollisionRadius, Loc)
	{
		// call the appropriate controller
		lambc = LambController(CheckP.Controller);
		if(lambc != None
			&& CheckP != CheckCreatorPawn
			&& CheckP != CheckOriginActor)
		{
			lambc.MarkerIsHere(UseClass, CheckCreatorPawn, CheckOriginActor, Loc);
		}
		else
		{
			p2p = P2Player(CheckP.Controller);
			if(p2p != None)
			{
				bPlayerNear=true;
				p2p.MarkerIsHere(UseClass, CheckCreatorPawn, CheckOriginActor, Loc);
			}
		}
	}
}

defaultproperties
{
}
