///////////////////////////////////////////////////////////////////////////////
// ArcadeController
// Copyright 2002 RWS, Inc.  All Rights Reserved.
//
// High-level RWS AI Controllers for the guy at the arcade
//
///////////////////////////////////////////////////////////////////////////////
class EAArcadeController extends EADaveController;

///////////////////////////////////////////////////////////////////////////////
// Look at this person's inventory and see if they're trying to buy something
// you sell and if it's not already paid for
///////////////////////////////////////////////////////////////////////////////
function Inventory HasYourProduct(P2Pawn CheckP, P2Pawn OrigOwner)
{
	local Inventory inv;
	local OwnedInv owninv;
	
	log(self@"hasyourproduct checkpawn"@Checkp@"original owner"@origowner);

	// Check his inventory for this item type
	// If it's class we want to see if it's stolen
	inv = CheckP.Inventory;
	while(inv != None)
		//&& !inv.LegalOwner == OrigOwner)
		//&& !inv.ClassIsChildOf(inv.class, InvClassToCheck))
	{
		log("checking"@inv);
		owninv = OwnedInv(inv);
		if (OwnInv == None)
		{
			log(inv@"not an OwnedInv");
		}
		else
		{
			log(owninv@"legal owner"@owninv.legalowner@"paid for"@owninv.bpaidfor);
		}

		if(owninv != None
			&& owninv.LegalOwner == OrigOwner
			&& !owninv.bPaidFor)
			return inv;
//		log("inv "$inv);
		inv = inv.Inventory;
	}

	return inv;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// ExchangeWithDude
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state ExchangeWithDude
{
	///////////////////////////////////////////////////////////////////////////////
	// Setup dude to deal with teller, by switching to the item I care about
	///////////////////////////////////////////////////////////////////////////////
	function SetupCustomer()
	{
		local OwnedInv owninv;
		local P2Player aplayer;
		
		log(self@"setup dude customer");

		owninv = OwnedInv(HasYourProduct(P2Pawn(InterestPawn), MyPawn));

		log(self@"owninv is"@Owninv);

		aplayer = P2Player(InterestPawn.Controller);

		CustomerPawn = P2MoCapPawn(InterestPawn);

		if(aplayer != None
			&& owninv != None)
		{
			// Fix up our default
			InterestInventoryClass = default.InterestInventoryClass;
			// link to the cashier who called you over
			aplayer.InterestPawn = MyPawn;
			aplayer.bDealingWithCashier=true;

			// Switch you over to showing this powerup in your item list
			aplayer.SwitchToThisPowerup(owninv.default.InventoryGroup,
									owninv.default.GroupOffset);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// WaitOnDudeToPay
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state WaitOnDudeToPay
{
Begin:
	// dude says hi
	PrintDialogue(InterestPawn$" greeting ");
	TalkSome(CustomerPawn.myDialog.lGreeting, CustomerPawn,true);
	Sleep(SayTime);

	if(CheckToGiggle())
		Sleep(SayTime);

	// Dave says hi
	TalkSome(MyPawn.myDialog.lGreeting,,true);
	PrintDialogue("Greeting");
	Sleep(SayTime);

	// Teller asks how she can help you
	PrintDialogue("can i help you?");
	TalkSome(MyPawn.myDialog.lCanIHelpYou);
	Sleep(SayTime);

	// dude says here's your gift dave
	PrintDialogue(InterestPawn$" here's your motherboard");
	TalkSome(CustomerPawn.myDialog.lDude_GiveToUncleDave, CustomerPawn);
	Sleep(SayTime);

	// Wait on dude to pay you for the thing
	log("waiting on motherboard");
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// TakePaymentFromDude
// Dave is grateful for the gift
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state TakePaymentFromDude
{
Begin:
	// Dave says thanks
	PrintDialogue("Thanks!");
	TalkSome(MyPawn.myDialog.lThanks);
	Sleep(SayTime);

	EAGameState(P2GameInfoSingle(Level.Game).TheGameState).SetBonusMission(1, True);
	FinishTransaction();

	// return to handling the cash register
	GotoState('WaitForCustomers');
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     InterestInventoryClass=Class'EAInventory.MotherboardInv'
}
