//=============================================================================
// Copyright 2004 Running With Scissors, Inc.  All Rights Reserved.
//
//	Warning!
//	Do not use any of the 'initial states' such as Attack Player or Panic with
// this character or he may do unpredictable things. He will not function as
// expected. Just place this guy and let him go for expected results.
//=============================================================================
class EACowHeadGaryPawn extends EAGaryPygmy
	placeable;


///////////////////////////////////////////////////////////////////////////////
// P2Pawn TakeDamage sends the real damage value into the Notify so when 
// this gary gets hit by anthrax, he doesn't get hurt, but he's constantly
// trying to reassess his attacker. Since we know he ignores it, it's ugly
// but let's just override it through new code. No anthrax hurts him.
///////////////////////////////////////////////////////////////////////////////
function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, class<DamageType> damageType)
{
	if(ClassIsChildOf(damageType, class'AnthDamage'))
	{
		if(TakesAnthraxDamage <= 0.0)
			return;
	}
	else
	{
		// This always blows up your head and kills you
		if(ClassIsChildOf(damageType, class'HeadKillDamage'))
		{
			ExplodeHead(HitLocation, Momentum);
			Damage = Health;
		}

		Super.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Setup and destroy head
///////////////////////////////////////////////////////////////////////////////
function SetupHead()
{
	Super.SetupHead();

	// rotate our cowhead carefully
	if(myHead != None)
	{
		//log(Self$" new head rot "$MyHead.default.RelativeRotation);
		MyHead.SetRelativeRotation(MyHead.default.RelativeRotation);
	}
}

///////////////////////////////////////////////////////////////////////////////
//	Don't allow the head to be popped off like normal, instead explode
// it even if they just cut the head off
///////////////////////////////////////////////////////////////////////////////
function PopOffHead(vector HitLocation, vector Momentum)
{
	ExplodeHead(HitLocation, Momentum);
}

defaultproperties
{
     SeverBone(0)="MALE01 L UpperArm"
     SeverBone(1)="MALE01 L Forearm"
     SeverBone(2)="MALE01 R UpperArm"
     SeverBone(3)="MALE01 R Forearm"
     SeverBone(4)="MALE01 L Thigh"
     SeverBone(5)="MALE01 L Calf"
     SeverBone(6)="MALE01 R Thigh"
     SeverBone(7)="MALE01 r calf"
     BoneArr(0)=1
     BoneArr(1)=1
     BoneArr(2)=1
     BoneArr(3)=1
     BoneArr(4)=1
     BoneArr(5)=1
     BoneArr(6)=1
     BoneArr(7)=1
     HeadClass=Class'EAPawns.EAGaryHeadCow'
     HeadSkin=Texture'StuffSkins.Items.CowHead_new'
     BodyHitSounds(0)=Sound'MiscSounds.People.bodyhitground1'
     BodyHitSounds(1)=Sound'MiscSounds.People.bodyhitground2'
     ChameleonMeshPkgs(0)="Characters"
     ChamelHeadSkins(0)="Texture'AW_Characters.Zombie_Heads.Pygmy_head"
     ChamelHeadSkins(1)="Texture'AW_Characters.Zombie_Heads.Zombie_Gary_01"
     ChamelHeadSkins(2)="Texture'AW_Characters.Zombie_Heads.Zombie_Gary_02"
     ChamelHeadSkins(3)="End"
     ChamelHeadMeshPkgs(0)="heads"
     Twitch=1.500000
     TakesAnthraxDamage=0.000000
     WeapChangeDist=0.000000
     dialogclass=Class'AWPawns.DialogCowHeadGary'
     BaseEquipment(0)=(WeaponClass=Class'ScissorsWeapon')
     BaseEquipment(1)=(WeaponClass=Class'GrenadeWeapon')
     BaseEquipment(2)=(WeaponClass=Class'Inventory.UrethraWeapon')
     HealthMax=50.000000
     ControllerClass=Class'EAPawns.EACowHeadGaryController'
     Skins(0)=Texture'AW_Characters.Zombie_Skins.Pygmy_skin'
     Begin Object Class=KarmaParamsSkel Name=KarmaParamsSkel17
         KSkeleton="Avg_Mini_Skel"
         KFriction=0.500000
         Name="KarmaParamsSkel17"
     End Object
     KParams=KarmaParamsSkel'EAPawns.KarmaParamsSkel17'
}
