///////////////////////////////////////////////////////////////////////////////
// AW7 limbs
///////////////////////////////////////////////////////////////////////////////
class EALimb extends Limb;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
var TimedMarker MyMarker;
var class<TimedMarker> MarkerClass;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
const LIMB_FIX_SPAN = 20.000000;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
event PostBeginPlay()
{
//	log(self@"PostBeginPlay");

	if (EAEarlyGameInfo(Level.Game) != None)
	{
		if (EAEarlyGameInfo(Level.Game).bLimbFix)
			LifeSpan = LIMB_FIX_SPAN;
//		else
			EAEarlyGameInfo(Level.Game).AddLimb(Self);
	}
	else
		LifeSpan = class'Limb'.Default.LifeSpan;


//	log(self@"calling SetupMarker()");
	SetupMarker();

	Super.PostBeginPlay();
}

function SetupMarker()
{
//	log(self@"entered SetupMarker()");
	MyMarker = Spawn(MarkerClass,self,,Location);
//	log(self@"my marker is"@MyMarker);
}

event Destroyed()
{
	if (MyMarker != None)
		MyMarker.Destroy();
}

///////////////////////////////////////////////////////////////////////////////
// Copied from Projectile
// For some reason, limbs go right through people, so we just copy over the
// functionality from Projectile and alter it
///////////////////////////////////////////////////////////////////////////////
simulated singular function Touch(Actor Other)
{
	local actor HitActor;
	local vector HitLocation, HitNormal, VelDir;
	local bool bBeyondOther;
	local float BackDist, DirZ;

	if ( Other.bProjTarget || (Other.bBlockActors && Other.bBlockPlayers) )
	{
		if ( Velocity == vect(0,0,0) )
		{
			ProcessTouch(Other,Location);
			return;
		}

		//get exact hitlocation - trace back along velocity vector
		bBeyondOther = ( (Velocity Dot (Location - Other.Location)) > 0 );
		VelDir = Normal(Velocity);
		DirZ = sqrt(VelDir.Z);
		BackDist = Other.CollisionRadius * (1 - DirZ) + Other.CollisionHeight * DirZ;
		if ( bBeyondOther )
			BackDist += VSize(Location - Other.Location);
		else
			BackDist -= VSize(Location - Other.Location);

	 	HitActor = Trace(HitLocation, HitNormal, Location, Location - 1.1 * BackDist * VelDir, true);
		if (HitActor == Other)
			ProcessTouch(Other, HitLocation);
		else if ( bBeyondOther )
			ProcessTouch(Other, Other.Location - Other.CollisionRadius * VelDir);
		else
			ProcessTouch(Other, Location);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
	local vector TheNorm;
	
	if (Pawn(Other) != None && bBounce)
	{
		TheNorm = Normal(Velocity);
		HitWall(TheNorm, Other);
		Bump(Other);
	}
}

defaultproperties
{
     MarkerClass=Class'EAPawns.DeadLimbMarker'
     LimbBounce(0)=Sound'AWSoundFX.Body.limbflop1'
     LimbBounce(1)=Sound'AWSoundFX.Body.limbflop2'
     Meshes(0)=StaticMesh'awpeoplestatic.Limbs.L_leg_limb'
     Meshes(1)=StaticMesh'awpeoplestatic.Limbs.L_leg_calf'
     Meshes(2)=StaticMesh'awpeoplestatic.Limbs.L_leg_foot'
     Meshes(3)=StaticMesh'awpeoplestatic.Limbs.R_leg_limb'
     Meshes(4)=StaticMesh'awpeoplestatic.Limbs.R_leg_calf'
     Meshes(5)=StaticMesh'awpeoplestatic.Limbs.R_leg_foot'
     Meshes(6)=StaticMesh'awpeoplestatic.Limbs.L_arm_limb'
     Meshes(7)=StaticMesh'awpeoplestatic.Limbs.L_arm_forearm'
     Meshes(8)=StaticMesh'awpeoplestatic.Limbs.L_hand'
     Meshes(9)=StaticMesh'awpeoplestatic.Limbs.R_arm_limb'
     Meshes(10)=StaticMesh'awpeoplestatic.Limbs.R_arm_forearm'
     Meshes(11)=StaticMesh'awpeoplestatic.Limbs.R_hand'
     SleeveMeshes(0)=StaticMesh'awpeoplestatic.Limbs.L_leg_limb_pants'
     SleeveMeshes(1)=StaticMesh'awpeoplestatic.Limbs.L_leg_foot_pants'
     SleeveMeshes(2)=StaticMesh'awpeoplestatic.Limbs.L_leg_calf_pants'
     SleeveMeshes(3)=StaticMesh'awpeoplestatic.Limbs.R_leg_limb_pants'
     SleeveMeshes(4)=StaticMesh'awpeoplestatic.Limbs.R_leg_foot_pants'
     SleeveMeshes(5)=StaticMesh'awpeoplestatic.Limbs.R_leg_calf_pants'
     Health=100.000000
     LifeSpan=0.000000
     Skins(0)=Texture'ChameleonSkins.Special.RWS_Shorts'
     Mass=100.000000
}
