class EAMilitary extends EAAuthorityFigure
	placeable;

function PreBeginPlay()
	{
	Super.PreBeginPlay();

	// Do this here because we can't use enums in default properties
	ChameleonOnlyHasGender = Gender_Male;
	}

function PostBeginPlay()
	{
	Super.PostBeginPlay();

	Cowardice=0.0;
	}

///////////////////////////////////////////////////////////////////////////////
// Record pawn dead, if player killed them
///////////////////////////////////////////////////////////////////////////////
function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
	if(P2GameInfoSingle(Level.Game) != None
		&& P2GameInfoSingle(Level.Game).TheGameState != None
		&& Killer != None
		&& Killer.bIsPlayer)
	{
		// Record him dying as military
		AWGameState(P2GameInfoSingle(Level.Game).TheGameState).ArmyKilled++;
	}

	Super.Died(Killer, damageType, HitLocation);
}

defaultproperties
{
     StumpClass=Class'AWPawns.StumpBigGuy'
     BlockMeleeFreq=0.900000
     bRandomizeHeadScale=False
     boltons(0)=(Bone="NODE_Parent",StaticMesh=StaticMesh'boltons.Swat_Helmet',Skin=Texture'BoltonSkins.Military_Helmet',bAttachToHead=True)
     boltons(1)=(Bone="MALE01 spine1",StaticMesh=StaticMesh'boltons.Military_Pack')
     ChameleonSkins(0)="ChameleonSkins.MM__074__Big_M_LS_Pants"
     ChameleonSkins(1)="ChameleonSkins.MW__076__Big_M_LS_Pants"
     ChameleonSkins(2)="End"
     Psychic=0.300000
     Champ=0.500000
     Cajones=0.700000
     Glaucoma=0.650000
     Rat=1.000000
     Compassion=0.300000
     WarnPeople=0.300000
     Conscience=0.300000
     Beg=0.20000
     PainThreshold=0.800000
     Reactivity=0.500000
     Rebel=1.000000
     WillDodge=0.200000
     WillUseCover=0.200000
     Stomach=0.900000
     Fitness=0.700000
     TakesMachinegunDamage=1.000000
     TakesPistolHeadShot=0.100000
     TakesShotgunHeadShot=0.100000
     TakesRifleHeadShot=0.100000
     TakesShovelHeadShot=0.100000
     TakesOnFireDamage=0.600000
     TakesAnthraxDamage=1.000000
     TakesChemDamage=1.000000
     TakesShockerDamage=0.400000
     TakesSledgeDamage=0.000000
     TakesMacheteDamage=0.650000
     TakesScytheDamage=1.000000
     TakesDervishDamage=0.650000
     TakesZombieSmashDamage=0.500000
     dialogclass=Class'BasePeople.DialogMaleMilitary'
     BaseEquipment(0)=(WeaponClass=Class'M4A1Weapon')
     BaseEquipment(1)=(WeaponClass=Class'BerettaWeapon')
     BaseEquipment(2)=(WeaponClass=Class'FootWeapon')
     BaseEquipment(3)=(WeaponClass=Class'FistsWeapon')
     BaseEquipment(4)=(WeaponClass=Class'Inventory.UrethraWeapon')
     ViolenceRankTolerance=0
     HealthMax=230.000000
     Gang="Military"
     WillDodge=0.500000
     WillKneel=0.500000
     WillUseCover=0.50000
     AttackRange=(Min=2048.000000,Max=4096.000000)
     ControllerClass=Class'EAPawns.EAMilitaryController'
     Mesh=SkeletalMesh'Characters.Big_M_LS_Pants'
     Skins(0)=Texture'ChameleonSkins.Military.XX__152__Big_M_LS_Pants'
}
