// EAPolice
// Base class for all police characters in EA.
// EA police are a lot stronger than normal Postal 2 police.
class EAPolice extends EAAuthorityFigure
	notplaceable
	Abstract;

///////////////////////////////////////////////////////////////////////////////
// Decide on a prize for a quick kill
///////////////////////////////////////////////////////////////////////////////
function PickQuickKillPrize(int KillIndex)
{
	local class<Inventory> invclass;
	local Inventory newone;

//	log(self@"PickQuickKillPrize");

	switch(KillIndex)
	{
		case 0:
			invclass = class'DonutInv';
		break;
		case 1:
			invclass = class'MoneyInv';
		break;
		case 2:
			invclass = class'FastFoodInv';
		break;
		case 4:
			invclass = class'CrackInv';
		break;
		case 6:
			invclass = class'CopClothesInv';
		break;
	}
//	log(self@"picked inventory type"@InvClass);
	newone = spawn(invclass, self);
//	log(self@"tossing inventory"@newone);
	TossThisInventory(vector(Rotation), newone);
}

///////////////////////////////////////////////////////////////////////////////
// Set dialog class
///////////////////////////////////////////////////////////////////////////////
function SetDialogClass()
{
	if (bIsFemale)
		DialogClass=class'EADialog.EADialogFemaleCop';
	else
		DialogClass=class'EADialog.EADialogMaleCop';
}

defaultproperties
{
     CopRadioClass=Class'EAInventory.CopRadioInv'
     BlockMeleeFreq=0.850000
     CloseWeaponIndex=2
     FarWeaponIndex=3
     bHasRadio=True
     boltons(0)=(Bone="cop_badge",StaticMesh=StaticMesh'boltons.cop_badge')
     ChamelHeadMeshPkgs(0)="heads"
     Psychic=0.200000
     Champ=0.500000
     Cajones=0.600000
     Temper=0.120000
     Glaucoma=0.800000
     Rat=1.000000
     Compassion=1.000000
     WarnPeople=1.000000
     Conscience=1.000000
     PainThreshold=1.000000
     Reactivity=0.400000
     Rebel=1.000000
     WillDodge=0.300000
     WillUseCover=0.600000
     TalkWhileFighting=0.000000
     TakesMachinegunDamage=1.000000
     TakesPistolHeadShot=1.000000
     TakesShotgunHeadShot=1.000000
     TakesRifleHeadShot=1.000000
     TakesShovelHeadShot=1.000000
     TakesOnFireDamage=0.500000
     TakesAnthraxDamage=1.000000
     TakesChemDamage=1.000000
     TakesShockerDamage=1.000000
     TakesSledgeDamage=1.000000
     TakesMacheteDamage=0.700000
     TakesScytheDamage=1.000000
     TakesDervishDamage=0.700000
     TakesZombieSmashDamage=0.700000
     Fitness=0.550000
     ViolenceRankTolerance=0
     HealthMax=300.000000
     Gang="Police"
     DonutLove=0.750000
     bFriendWithAuthority=True
     FriendDamageThreshold=0.000000
     AttackRange=(Min=2048.000000,Max=4096.000000)
     ControllerClass=Class'EAPawns.EAPoliceController'
}
