//=============================================================================
// PublisherGuard
// Copyright 2004 Running With Scissors, Inc.  All Rights Reserved.
//
//=============================================================================
class EAPublisherGuard extends EAPerson
	placeable;

///////////////////////////////////////////////////////////////////////////////
// Adds all the required equipment and picks out the urethra.
// Do this here so we access to the inventory package for specific things
// like HandsWeapon and UrethraWeapon.
// Publisher guards get random arsenals
///////////////////////////////////////////////////////////////////////////////
function AddDefaultInventory()
{
	local int i;

	// Only let this be called once
	if (!bGotDefaultInventory)
	{
		i = rand(4);
		switch(i)
		{
			case 0:
				CreateInventoryByClass(class'M870Weapon');
				break;
			case 1:
				CreateInventoryByClass(class'GSelectWeapon');
				break;
			case 2:
				CreateInventoryByClass(class'BerettaWeapon');
				break;
			case 3:
				CreateInventoryByClass(class'M4A1Weapon');
				break;
			case 4:
				CreateInventoryByClass(class'UZIWeapon');
				break;
			case 5:
				CreateInventoryByClass(class'M16A2Weapon');
				break;
			case 6:
				CreateInventoryByClass(class'AK47Weapon');
				break;
		}
	}
	
	Super.AddDefaultInventory();
}

defaultproperties
{
     bCellUser=False
     BlockMeleeFreq=0.950000
     Psychic=0.400000
     Champ=0.700000
     Cajones=0.700000
     Temper=0.350000
     Glaucoma=0.450000
     Rat=1.000000
     Compassion=0.000000
     WarnPeople=0.000000
     Conscience=0.000000
     Beg=0.000000
     PainThreshold=1.000000
     Reactivity=0.750000
     Rebel=1.000000
     WillDodge=0.400000
     WillKneel=0.200000
     WillUseCover=0.800000
     Armor=100.000000
     ArmorMax=100.000000
     TalkWhileFighting=0.100000
     TakesMachinegunDamage=1.000000
     TakesPistolHeadShot=1.000000
     TakesShotgunHeadShot=1.000000
     TakesRifleHeadShot=1.000000
     TakesShovelHeadShot=1.000000
     TakesOnFireDamage=0.200000
     TakesAnthraxDamage=1.000000
     TakesChemDamage=1.000000
     TakesShockerDamage=0.100000
     TakesSledgeDamage=1.000000
     TakesMacheteDamage=1.000000
     TakesScytheDamage=1.000000
     TakesDervishDamage=0.700000
     TakesZombieSmashDamage=0.700000
     TalkBeforeFighting=0.100000
     Fitness=0.900000
     bAuthorityFigure=True
     dialogclass=Class'BasePeople.DialogMaleMilitary'
     ViolenceRankTolerance=0
     HealthMax=230.000000
     bPlayerIsEnemy=True
     Gang="PublisherGuard"
     AttackRange=(Min=2096.000000,Max=4096.000000)
     ControllerClass=Class'EAPawns.EAMilitaryController'
     bAdvancedFiring=True
     Mesh=SkeletalMesh'Characters.Avg_M_SS_Pants'
     Skins(0)=Texture'AW_Characters.Special.Bullfish_Security'
}
