///////////////////////////////////////////////////////////////////////////////
// RWSController
// Copyright 2002 RWS, Inc.  All Rights Reserved.
//
// I work at RWS and will fight for Vince to the death! Or.. pretty close to death at least
//
///////////////////////////////////////////////////////////////////////////////
class EARWSController extends AWRWSController;

///////////////////////////////////////////////////////////////////////////////
// Vars
///////////////////////////////////////////////////////////////////////////////
// User set vars

// Internal vars
var bool bToldPlayer;		// You've told the player he needs to see vince if this is true

const TELL_DUDE_RADIUS	=	128;
/*
const MAX_ROT_DIFF = 1024;

///////////////////////////////////////////////////////////////////////////////
// Bystanders have view pitching now
///////////////////////////////////////////////////////////////////////////////
simulated event Tick(float Delta)
{
	local rotator ORot;
	local vector VDiff;
	local float PDiff;

	Super.Tick(Delta);

	if (Focus != None && !Focus.bStatic)
	{
		VDiff = Focus.Location - Pawn.Location;
		ORot = Rotator(VDiff);
		if (abs(Pawn.Rotation.Yaw - ORot.Yaw) < MAX_ROT_DIFF
			&& !IsInState('ThrownThroughAir')
			&& !IsInState('DoPuking')
			&& !IsInState('BeingShocked')
			&& !IsInState('RestFromAttacker')
			&& !IsInState('DanceHere')
			&& !IsInState('PlayArcadeGame')
			&& !IsInState('AttackedByChompy')
			&& !IsInState('WipeFace')
			&& !IsInState('PrepDeathCrawl')
			&& !IsInState('RunOnFire')
			&& !IsInState('DeathCrawlFromAttacker')
			&& !IsInState('CowerInABall')
			&& !IsInState('ImOnFire')
			)
			Pawn.ViewPitch = Clamp(ORot.Pitch / 256, 0, 255);
		else
			Pawn.ViewPitch = 0;
//		log(self@"focus is"@Focus@"VDiff"@VDiff@"ORot"@ORot@"Rotation"@Pawn.Rotation);
	}
	else
		Pawn.ViewPitch = 0;
}
*/
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function SetupTellDude(P2Pawn LookAtMe)
{
	// If it's the dude and he hasn't done it, then tell him to go see vince
	InterestPawn = LookAtMe;
	if(IsInState('LegMotionToTarget'))
		bPreserveMotionValues=true;
	SetEndGoal(LookAtMe, TELL_DUDE_RADIUS);
	SwitchToHands();
	MyPawn.ChangeAnimation();
	SetNextState('TellDudeAboutVince');
	GotoStateSave('WalkToDude');
}

///////////////////////////////////////////////////////////////////////////////
// If the dude hasn't completed the vince errand, tell him
///////////////////////////////////////////////////////////////////////////////
function CheckObservePawnLooks(FPSPawn LookAtMe)
{
	if(LookAtMe.bPlayer
		&& !bToldPlayer
		&& !P2GameInfoSingle(Level.Game).bIsDemo
		&& !P2GameInfoSingle(Level.Game).CorrectDayForErrand("GetPaycheck", "7DAYA", true)
		&& Attacker != LookAtMe
		&& MyPawn.MyBodyChem == None)
	{
		// if it's the dude and he hasn't done it, then tell him to go see vince
		SetupTellDude(P2Pawn(LookAtMe));
		return;
	}

	Super.CheckObservePawnLooks(LookAtMe);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Stand this way, and play and arcade game.. make a mean face sometimes
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state PlayArcadeGame
{
	ignores SetupTellDude;
	// RWS guys playing keep wanting to play--not to see the dude and then
	// go tell him to see vince
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// WalkToDude
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state WalkToDude extends WalkToTarget
{
	ignores SetupTellDude, FreeToSeekPlayer;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// TellDudeAboutVince
// Dude needs to see vince
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state TellDudeAboutVince extends TalkingWithSomeoneMaster
{
	ignores SetupTellDude;

Begin:
	if(InterestPawn != None)
	{
		// Make sure dude is alive
		if(InterestPawn.Health > 0)
		{
			// Check just before we tell him, if we've already told him or not
			if(!bToldPlayer)
			{
				// Check first if we don't have anything in the way of us telling
				// him about vince
				if(CanSeePoint(MyPawn, InterestPawn.Location))
				{
					bToldPlayer=true;
					// RWS employee tells dude to go find vince
					PrintDialogue("go find vince");
					TalkSome(MyPawn.myDialog.lRWSEmployee,,true);
					Sleep(SayTime);

					// Dude thanks them
					PrintDialogue(InterestPawn$" thanks ");
					TalkSome(P2Pawn(InterestPawn).myDialog.lThanks, P2Pawn(InterestPawn), true);
					Sleep(SayTime);
				}
			}
		}
		else
			bToldPlayer=true;
	}

	GotoStateSave('Thinking');
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// ShootAtAttacker
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state ShootAtAttacker
{
	///////////////////////////////////////////////////////////////////////////////
	// If it's a buddy, in a gun fight, listen to them and just crouch
	///////////////////////////////////////////////////////////////////////////////
	function ForceGetDown(Pawn Shouter, Pawn AttackingShouter)
	{
		if(MyPawn.Physics == PHYS_WALKING
			&& (Shouter.Tag == 'RWSVince' || Shouter.Tag == 'AWRWSVince'))
		{
			MyPawn.ShouldCrouch(true);
		}
		// otherwise ignore him
	}

	///////////////////////////////////////////////////////////////////////////
	// I've been attacked by someone (again)
	///////////////////////////////////////////////////////////////////////////
	function damageAttitudeTo(pawn Other, float Damage)
	{
		// if not vince, react accordingly
		if(Other == None
			|| (Other.Tag != 'RWSVince' && Other.Tag != 'AWRWSVince'))
		{
			Super.damageAttitudeTo(Other, Damage);
		}
	}
}

defaultproperties
{
}
