//=============================================================================
// SWAT
// Copyright 2001 Running With Scissors, Inc.  All Rights Reserved.
//
// Base class for all SWAT characters.
//
//=============================================================================
class EASWAT extends EAMilitary;

///////////////////////////////////////////////////////////////////////////////
// Record pawn dead, if player killed them
///////////////////////////////////////////////////////////////////////////////
function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
	// Skip counting SWAT kills as military kills
	Super(EAAuthorityFigure).Died(Killer, damageType, HitLocation);
}

simulated event PostBeginPlay()
{
	Super.PostBeginPlay();
	
	if (Role == ROLE_Authority)
		TakesSledgeDamage = 1.0;
}

defaultproperties
{
     HeadSkin=Texture'ChamelHeadSkins.Special.Robber'
     HeadMesh=SkeletalMesh'heads.Masked'
     boltons(0)=(StaticMesh=StaticMesh'boltons.Swat_Goggles')
     boltons(1)=(bInActive=True)
     ChameleonSkins(0)="ChameleonSkins.MW__071__Big_M_LS_Pants"
     ChameleonSkins(2)="End"
     ChameleonMeshPkgs(0)="Characters"
     ChamelHeadMeshPkgs(0)="heads"
     Psychic=0.400000
     Champ=0.700000
     Temper=0.350000
     Glaucoma=0.450000
     Compassion=0.000000
     WarnPeople=0.000000
     Conscience=0.000000
     Beg=0.400000
     PainThreshold=1.000000
     Reactivity=0.750000
     WillDodge=0.700000
     WillKneel=0.700000
     WillUseCover=0.700000
     Stomach=1.000000
     Armor=100.000000
     ArmorMax=200.000000
     TalkWhileFighting=0.100000
     TakesSledgeDamage=0.700000
     TakesZombieSmashDamage=1.000000
     TalkBeforeFighting=0.100000
     Fitness=0.900000
     BaseEquipment(0)=(WeaponClass=Class'MP5Weapon')
     BaseEquipment(1)=(WeaponClass=Class'BerettaWeapon')
     BaseEquipment(2)=(WeaponClass=Class'FootWeapon')
     BaseEquipment(3)=(WeaponClass=Class'FistsWeapon')
     BaseEquipment(4)=(WeaponClass=Class'Inventory.UrethraWeapon')
     HealthMax=280.000000
     Gang="SWAT"
     AttackRange=(Min=2048.000000)
     Skins(0)=Texture'ChameleonSkins.SWAT.XX__159__Big_M_LS_Pants'
}
