///////////////////////////////////////////////////////////////////////////////
// AWMainMenu.uc
// Copyright 2003 Running With Scissors, Inc.  All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////
// This class describes the main menu details and processes main menu events.
///////////////////////////////////////////////////////////////////////////////
class EAMainMenu extends MenuMain;
//class EAMainMenu extends AWMainMenu;

var bool bIsDemo;

///////////////////////////////////////////////////////////////////////////////
// Create menu contents
///////////////////////////////////////////////////////////////////////////////
function CreateMenuContents()
{
	Super(BaseMenuBig).CreateMenuContents();
	AddTitleBitmap(TitleTexture);

	NewChoice     = AddChoice(NewGameText,		"",									ItemFont, ItemAlign);
	LoadChoice    = AddChoice(LoadGameText,		OptionUnavailableInDemoHelpText,	ItemFont, ItemAlign);
	LoadChoice.bActive = !GetLevel().IsDemoBuild();
	MultiChoice   = AddChoice(MultiText,		"",									ItemFont, ItemAlign);
	OptionsChoice = AddChoice(OptionsText,		"",									ItemFont, ItemAlign);
	ExitChoice    = AddChoice(ExitGameText,		"",									ItemFont, ItemAlign);

	// Reset this value. When MenuDifficultyPatch starts up, it's the only one that needs it
	// and it will set it when necessary.
	ShellRootWindow(Root).bFixSave=false;
}

///////////////////////////////////////////////////////////////////////////////
// Handle notifications from controls
///////////////////////////////////////////////////////////////////////////////
function Notify(UWindowDialogControl C, byte E)
	{
	local bool bHandled;

	switch(E)
		{
		case DE_Click:
			if (C != None)
				switch (C)
					{
					case NewChoice:
						// Start new game
						SetSingleplayer();
						ShellRootWindow(Root).bVerifiedPicked=false;
						if (!bIsDemo)
							GotoMenu(class'EAMenuStart');
						else
							GotoMenu(class'MenuImageKeys');
						bHandled = true;
						break;
					}
			break;
		}

	if (!bHandled)
		Super.Notify(C, E);
	}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     TitleTexture=Texture'EATex.Misc.AW7Menu'
     astrTextureDetailNames(0)="UltraLow"
     astrTextureDetailNames(1)="Low"
     astrTextureDetailNames(2)="Medium"
     astrTextureDetailNames(3)="High"
}
