class EAMenuOptions extends AWMenuOptions;

///////////////////////////////////////////////////////////////////////////////
// Vars, structs, consts, enums...
///////////////////////////////////////////////////////////////////////////////
var() class<ShellMenuCW> MenuGameOptionsClass;
var() class<ShellMenuCW> MenuPerformanceClass;
var() class<ShellMenuCW> MenuControlsClass;

function CreateMenuContents()
	{
	//Super.CreateMenuContents();

	AddTitle(OptionsText, TitleFont, TitleAlign);

	GameChoice			= AddChoice(GameOptionsText,	GameOptionsHelp,	ItemFont, ItemAlign);
	ControlsChoice		= AddChoice(ControlOptionsText, ControlOptionsHelp,	ItemFont, ItemAlign);
	VideoChoice			= AddChoice(VideoOptionsText,	VideoOptionsHelp,	ItemFont, ItemAlign);
	AudioChoice			= AddChoice(AudioOptionsText,	AudioOptionsHelp,	ItemFont, ItemAlign);
	PerformanceChoice	= AddChoice(PerformanceText,	PerformanceHelp,	ItemFont, ItemAlign);


//dopamine STUPID bInDemo not around
//	if(bInDemo)
//		{
//		CustomMapChoice	= AddChoice(CustomMapText,		OptionUnavailableInDemoHelpText,ItemFont, ItemAlign);
//		CustomMapChoice.bActive=false;
//		}
//	else
		CustomMapChoice	= AddChoice(CustomMapText,		CustomMapHelp,		ItemFont, ItemAlign);
//	if (!bInDemo)

//dopamine removed to main menu		CreditsChoice	= AddChoice(CreditsText,		CreditsHelp,		ItemFont, ItemAlign);
	BackChoice			= AddChoice(BackText, "", ItemFont, ItemAlign, true);
	}
	

///////////////////////////////////////////////////////////////////////////////
// Handle notifications from controls
///////////////////////////////////////////////////////////////////////////////
function Notify(UWindowDialogControl C, byte E)
	{
	Super(ShellMenuCW).Notify(C, E);
	switch(E)
		{
		case DE_Click:
			if (C != None)
				switch (C)
					{
					case BackChoice:
						GoBack();
						break;
					case VideoChoice:
						GoToMenu(class'MenuVideo');
						break;
					case AudioChoice:
						GoToMenu(class'MenuAudio');
						break;
					case ControlsChoice:
						GoToMenu(class'EDMenuControls');
						break;
					case GameChoice:
						GoToMenu(class'EAMenuGameSettings');
						break;
					case PerformanceChoice:
						GoToMenu(class'EAMenuPerformance');
						break;
/* dopamine removed to main menu
					case CreditsChoice:
						GoToMenu(class'MenuImageCredits');
						break;
*/
					case CustomMapChoice:
						Root.ShowModal(Root.CreateWindow(class'ShellMapListFrame', 
										(Root.WinWidth - CustomMapWidth) /2, 
										(Root.WinHeight - CustomMapHeight) /2, 
										CustomMapWidth, CustomMapHeight, self));
						break;
					}
			break;
		}
	}


///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     MenuGameOptionsClass=Class'EAShell.EAMenuGameSettings'
     MenuPerformanceClass=Class'EAShell.EAMenuPerformance'
     MenuControlsClass=Class'EDShell.EDMenuControls'
     astrTextureDetailNames(0)="UltraLow"
     astrTextureDetailNames(1)="Low"
     astrTextureDetailNames(2)="Medium"
     astrTextureDetailNames(3)="High"
}
